/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: fader.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 00:39:06 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

//STRIP001 #ifndef _SD_FADER_HXX
//STRIP001 #define _SD_FADER_HXX

//STRIP001 #ifndef _COM_SUN_STAR_PRESENTATION_FADEEFFECT_HPP_
//STRIP001 #include <com/sun/star/presentation/FadeEffect.hpp>
//STRIP001 #endif

//STRIP001 #ifndef _SV_WINDOW_HXX //autogen
//STRIP001 #include <vcl/window.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_VIRDEV_HXX //autogen
//STRIP001 #include <vcl/virdev.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_TIMER_HXX //autogen
//STRIP001 #include <vcl/timer.hxx>
//STRIP001 #endif

//STRIP001 #ifdef UNX
//STRIP001 #undef None
//STRIP001 #endif

//STRIP001 #include "fadedef.h"
//STRIP001 #include "speedctl.hxx"

/*************************************************************************
|*
|* Durchfuehrung von Ueberblendeffekten fuer die Diashow
|*
\************************************************************************/

//STRIP001 #define WAIT_IN_EFFECT_MS	50
//STRIP001 #define FADER_MAGIC			0x3456789a

//STRIP001 class FuSlideShow;

//STRIP001 class Fader
//STRIP001 {
//STRIP001 private:

//STRIP001 	MapMode         aOldMMWin;
//STRIP001 	MapMode         aOldMMVDev;
//STRIP001 	MapMode         aOldMMVDevOld;
//STRIP001 	Timer           aTimer;
//STRIP001 	Rectangle       aSource;
//STRIP001 	Rectangle       aTarget;
//STRIP001 	Rectangle       aSourceLog;
//STRIP001 	Rectangle       aTargetLog;
//STRIP001 	Window*         pWin;
//STRIP001 	FuSlideShow*	pFuslShow;
//STRIP001 	VirtualDevice*  pVDev;
//STRIP001 	VirtualDevice*  pVDevOld;
//STRIP001 	ULONG			nPushCount;
//STRIP001 	ULONG           nStep;
//STRIP001 	ULONG           nMagic;
//STRIP001 	::com::sun::star::presentation::FadeEffect eEffect;
//STRIP001 	FadeSpeed       eSpeed;
//STRIP001 	USHORT          nRowCount;
//STRIP001 	USHORT          nColCount;
//STRIP001 	USHORT          nPrefCellSize;
//STRIP001 	BOOL            bPixelMode;
//STRIP001 	SpeedControl	aCtrl;

//STRIP001 	ULONG			GetEffectSteps( FadeSpeed eSpeed ) const;
//STRIP001 	void			WaitInEffect( ULONG nMilliSeconds ) const;

//STRIP001 	void			SwitchToPixel();
//STRIP001 	void			SwitchToLogic();

//STRIP001 	Rectangle		GetCell( USHORT nCol, USHORT nRow ) const;
//STRIP001 	void			CalcCellParams( USHORT nCells );

//STRIP001 	void			None( BOOL bWithBeep );

//STRIP001 	void			MoveFromLeft();
//STRIP001 	void			MoveFromUpperLeft();
//STRIP001 	void			MoveFromTop();
//STRIP001 	void			MoveFromUpperRight();
//STRIP001 	void			MoveFromRight();
//STRIP001 	void			MoveFromLowerRight();
//STRIP001 	void			MoveFromBottom();
//STRIP001 	void			MoveFromLowerLeft();

//STRIP001 	void			UncoverToLeft();
//STRIP001 	void			UncoverToUpperLeft();
//STRIP001 	void			UncoverToTop();
//STRIP001 	void			UncoverToUpperRight();
//STRIP001 	void			UncoverToRight();
//STRIP001 	void			UncoverToLowerRight();
//STRIP001 	void			UncoverToBottom();
//STRIP001 	void			UncoverToLowerLeft();

//STRIP001 	void			FadeFromLeft();
//STRIP001 	void			FadeFromUpperLeft();
//STRIP001 	void			FadeFromTop();
//STRIP001 	void			FadeFromUpperRight();
//STRIP001 	void			FadeFromRight();
//STRIP001 	void			FadeFromLowerRight();
//STRIP001 	void			FadeFromBottom();
//STRIP001 	void			FadeFromLowerLeft();

//STRIP001 	void			FadeFromCenter();
//STRIP001 	void			FadeToCenter();

//STRIP001 	void			RollFromTop();
//STRIP001 	void			RollFromLeft();
//STRIP001 	void			RollFromRight();
//STRIP001 	void			RollFromBottom();

//STRIP001 	void			VerticalCheckerboard();
//STRIP001 	void			HorizontalCheckerboard();

//STRIP001 	void			VerticalStripes();
//STRIP001 	void			HorizontalStripes();

//STRIP001 	void			Clockwise();
//STRIP001 	void			CounterClockwise();

//STRIP001 	void			CloseVertical();
//STRIP001 	void			CloseHorizontal();
//STRIP001 	void			OpenVertical();
//STRIP001 	void			OpenHorizontal();

//STRIP001 	void			CellsRandom();
//STRIP001 	void			CellsSpiralOutClockwise();
//STRIP001 	void			CellsSpiralOutCounterClockwise();
//STRIP001 	void			CellsSpiralInClockwise();
//STRIP001 	void			CellsSpiralInCounterClockwise();
//STRIP001 	void			CellsWavyLineFromTop();
//STRIP001 	void			CellsWavyLineFromLeft();
//STRIP001 	void			CellsWavyLineFromRight();
//STRIP001 	void			CellsWavyLineFromBottom();

//STRIP001 	void			RandomEffect();

//STRIP001 	void			StretchFromTop();
//STRIP001 	void			StretchFromLeft();
//STRIP001 	void			StretchFromRight();
//STRIP001 	void			StretchFromBottom();

//STRIP001 	void			VerticalLines();
//STRIP001 	void			HorizontalLines();

//STRIP001 	void			Test();

//STRIP001  public:
//STRIP001 					Fader( Window* pWindow, FuSlideShow* pShow = NULL );
//STRIP001 					~Fader();

//STRIP001 	void			SetWindow( Window* pNewWindow ) { pWin = pNewWindow; }
//STRIP001 	Window* 		GetWindow() const { return pWin; }

//STRIP001 	void			SetOldVirtualDevice( VirtualDevice* pDev );
//STRIP001 	void			SetNewVirtualDevice( VirtualDevice* pDev );

//STRIP001 	void			SetEffect( ::com::sun::star::presentation::FadeEffect eNewEffect ) { eEffect = eNewEffect; }
//STRIP001 	::com::sun::star::presentation::FadeEffect		GetEffect() const { return eEffect; }

//STRIP001 	void			SetSpeed( FadeSpeed eNewSpeed ) { eSpeed = eNewSpeed; }
//STRIP001 	FadeSpeed		GetSpeed() const { return eSpeed; }

//STRIP001 	void			SetSource( const Rectangle& rRect ) { aSourceLog = rRect; }
//STRIP001 	void			SetTarget( const Rectangle& rRect ) { aTargetLog = rRect; }
//STRIP001 	Rectangle		GetSource() const { return aSourceLog; }
//STRIP001 	Rectangle		GetTarget() const { return aTargetLog; }

//STRIP001 	void			Fade();
//STRIP001 	void			Terminate() { aCtrl.Terminate(); nMagic = 0UL; }
//STRIP001 };

//STRIP001 #endif // _SD_FADER_HXX


