/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sfx2_objmnctl.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 03:41:49 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// auto strip #include <tools/list.hxx>
#ifndef _MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
// auto strip #ifndef _PSEUDO_HXX //autogen
// auto strip #include <so3/pseudo.hxx>
// auto strip #endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#pragma hdrstop

#include "sfxsids.hrc"
#include "objmnctl.hxx"
#include "dispatch.hxx"
// auto strip #include "viewsh.hxx"
// auto strip #include "viewfrm.hxx"
namespace binfilter {

// STATIC DATA -----------------------------------------------------------

/*N*/ SFX_IMPL_MENU_CONTROL(SfxObjectVerbsControl, SfxStringItem);

//--------------------------------------------------------------------

/*
	Ctor; setzt Select-Handler am Menu und traegt Menu
	in seinen Parent ein.
 */

/*?*/ SfxObjectVerbsControl::SfxObjectVerbsControl(USHORT nId, Menu &rMenu, SfxBindings &rBindings)
/*?*/     : SfxMenuControl( nId, rBindings )
/*?*/     , pMenu(new PopupMenu)
/*?*/     , rParent(rMenu)
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	rMenu.SetPopupMenu(nId, pMenu);
//STRIP001 	pMenu->SetSelectHdl(LINK(this, SfxObjectVerbsControl, MenuSelect));
//STRIP001 	FillMenu();
/*?*/ }

//--------------------------------------------------------------------

/*
	Fuellt das Menu mit den aktuellen Verben aus der ViewShell.
 */

//STRIP001 void SfxObjectVerbsControl::FillMenu()
//STRIP001 {
//STRIP001 	pMenu->Clear();
//STRIP001     SfxViewShell *pView = GetBindings().GetDispatcher()->GetFrame()->GetViewShell();
//STRIP001 	if (pView)
//STRIP001 	{
//STRIP001 		const SvVerbList *pList = pView->GetVerbs();
//STRIP001 		if (pList)
//STRIP001 		{
//STRIP001 			USHORT nId = SID_VERB_START;
//STRIP001 			for (USHORT n=0; n<pList->Count(); n++)
//STRIP001 			{
//STRIP001 				const SvVerb& rVerb = (*pList)[n];
//STRIP001 				if (!rVerb.IsOnMenu())
//STRIP001 					continue;
//STRIP001 
//STRIP001 				DBG_ASSERT(nId <= SID_VERB_END, "Zuviele Verben!");
//STRIP001 				if (nId > SID_VERB_END)
//STRIP001 					break;
//STRIP001 
//STRIP001 				pMenu->InsertItem(nId++, rVerb.GetName());
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	rParent.EnableItem( GetId(), (BOOL)pMenu->GetItemCount() );
//STRIP001 }

//--------------------------------------------------------------------

/*
	Statusbenachrichtigung;
	fuellt gfs. das Menu mit den aktuellen Verben aus der ViewShell.
	der DocumentShell.
	Ist die Funktionalit"at disabled, wird der entsprechende
	Menueeintrag im Parentmenu disabled, andernfalls wird er enabled.
 */

//STRIP001 void SfxObjectVerbsControl::StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 										  const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	rParent.EnableItem(GetId(), SFX_ITEM_AVAILABLE == eState );
//STRIP001 	if ( SFX_ITEM_AVAILABLE == eState )
//STRIP001 		FillMenu();
//STRIP001 }

//--------------------------------------------------------------------

/*
	Select-Handler des Menus;
	das selektierte Verb mit ausgef"uhrt,
 */

//STRIP001 IMPL_LINK_INLINE_START( SfxObjectVerbsControl, MenuSelect, Menu *, pMenu )
//STRIP001 {
//STRIP001 	const USHORT nId = pMenu->GetCurItemId();
//STRIP001     if( nId )
//STRIP001         GetBindings().Execute(nId);
//STRIP001 	return 1;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SfxObjectVerbsControl, MenuSelect, Menu *, pMenu )

//--------------------------------------------------------------------

/*
	Dtor; gibt das Menu frei.
 */

//STRIP001 SfxObjectVerbsControl::~SfxObjectVerbsControl()
//STRIP001 {
//STRIP001 	delete pMenu;
//STRIP001 }

//--------------------------------------------------------------------

//STRIP001 PopupMenu* SfxObjectVerbsControl::GetPopup() const
//STRIP001 {
//STRIP001 	return pMenu;
//STRIP001 }


}
