/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_nforient.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 04:56:03 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop
#include "nforient.hxx"
namespace binfilter {

//STRIP001 #define ORIENT_SPIN		5


//STRIP001 void SvxOrientationField::Init( short _nMin, short _nMax )
//STRIP001 {
//STRIP001 	SetStrictFormat( TRUE );
//STRIP001 	SetSpinSize( ORIENT_SPIN );
//STRIP001 	nMinVal = _nMin;
//STRIP001 	nMaxVal = _nMax;
//STRIP001 	SetMin( -_nMax );
//STRIP001 	SetMax( _nMax );
//STRIP001 }


/*************************************************************************
#*	Member:		SvxOrientationField							Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Konstruktor der Klasse SvxOrientationField
#*
#*  Input:		Parent-Window, WinBits, min. Winkel, max. Winkel
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 SvxOrientationField::SvxOrientationField( Window* pParent, WinBits nWinStyle, short _nMin, short _nMax ):
//STRIP001 	NumericField( pParent, nWinStyle )
//STRIP001 {
//STRIP001 	Init( _nMin, _nMax );
//STRIP001 }

/*************************************************************************
#*	Member:		SvxOrientationField							Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Konstruktor der Klasse SvxOrientationField
#*
#*  Input:		Parent-Window, Resource, min. Winkel, max. Winkel
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 SvxOrientationField::SvxOrientationField( Window* pWindow, const ResId& rResId, short _nMin, short _nMax ) :
//STRIP001 	NumericField( pWindow, rResId )
//STRIP001 {
//STRIP001 	Init( _nMin, _nMax );
//STRIP001 }

/*************************************************************************
#*	Member:		Up											Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Funktion, die aufgerufen wird, wenn der Spin-Button 'Up'
#*				ausgeloest wird. Sorgt fuer das dynamische Zaehlverhalten.
#*				Wenn der Max- Wert ueberschritten wird, so wird der Min-
#*				Wert eingestellt.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void SvxOrientationField::Up()
//STRIP001 {
//STRIP001 	long	nVal = GetValue();
//STRIP001 	nVal += GetSpinSize();
//STRIP001 
//STRIP001 	if( nVal > nMaxVal )
//STRIP001 	{
//STRIP001 		nVal -= nMaxVal;
//STRIP001 		nVal--;
//STRIP001 	}
//STRIP001 
//STRIP001 	SetValue( nVal );
//STRIP001 
//STRIP001 	CtrPrivatModify();
//STRIP001 }

/*************************************************************************
#*	Member:		Down										Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Funktion, die aufgerufen wird, wenn der Spin-Button 'Down'
#*				ausgeloest wird. Sorgt fuer das dynamische Zaehlverhalten.
#*				Wenn der Min- Wert unterschritten wird, so wird der Max-
#*				Wert eingestellt.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void SvxOrientationField::Down()
//STRIP001 {
//STRIP001 	long	nVal = GetValue();
//STRIP001 	nVal -= GetSpinSize();
//STRIP001 
//STRIP001 	if( nVal < nMinVal )
//STRIP001 	{
//STRIP001 		nVal += nMaxVal;
//STRIP001 		nVal++;
//STRIP001 	}
//STRIP001 
//STRIP001 	SetValue( nVal );
//STRIP001 	CtrPrivatModify();
//STRIP001 
//STRIP001 }

/*************************************************************************
#*	Member:		Modify										Datum:10.09.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxOrientationField
#*
#*  Funktion:	Wird aufgerufen, wenn das Editfeld geaendert wurde.
#*				Es werden die letzten beiden Werte gespeichert.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/

//STRIP001 void SvxOrientationField::Modify()
//STRIP001 {
//STRIP001 	NumericField::Modify();
//STRIP001 	CtrPrivatModify();
//STRIP001 }

/*************************************************************************
#*	Member:		CtrModified									Datum:20.10.97
#*------------------------------------------------------------------------
#*
#*  Klasse:		SvxCtrDial
#*
#*  Funktion:	Teilt einem installierten Handler mit, dass
#*				eine Veraenderung eingetreten ist.
#*
#*  Input:		---
#*
#*	Output:		---
#*
#************************************************************************/
//STRIP001 void SvxOrientationField::CtrPrivatModify()
//STRIP001 {
//STRIP001 	aPrivModifyLink.Call( this );
//STRIP001 }


}
