/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: fmsrccfg.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 06:04:27 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _FMSRCCF_HXX_
#define _FMSRCCF_HXX_

// auto strip #ifndef _STRING_HXX //autogen
// auto strip #include <tools/string.hxx>
// auto strip #endif

// auto strip #ifndef _SFXCFGITEM_HXX //autogen
// auto strip #include <bf_sfx2/cfgitem.hxx>
// auto strip #endif
// auto strip #ifndef UNOTOOLS_CONFIGVALUECONTAINER_HXX
// auto strip #include <unotools/configvaluecontainer.hxx>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
// auto strip #include <com/sun/star/uno/Sequence.hxx>
// auto strip #endif
namespace binfilter {

// ===================================================================================================

#define MATCHING_ANYWHERE		0
#define MATCHING_BEGINNING		1
#define MATCHING_END			2
#define MATCHING_WHOLETEXT		3

// diese Konstanten duerfen NICHT einfach geaendert werden, da der SearchDialog aus den Einstellungen seiner ListBox
// keine Umrechnungen vornimmt, sondern die einfach in die entsprechenden Methoden der SearchEngine steckt
// (wenn man also die Konstanten oder die Reihenfolge der Listbox-Eintraege im Dialog aendert, muss das jeweils andere
// angepasst werden)


//........................................................................
namespace svxform
{
//........................................................................

	// ===================================================================================================
	// = struct FmSearchParams - Parameter einer Suche
	// ===================================================================================================

//STRIP001 	struct FmSearchParams
//STRIP001 	{
//STRIP001 	protected:
//STRIP001 		sal_Int32		nTransliterationFlags;
//STRIP001 			// they're way too sensitive for direct access ....
//STRIP001 
//STRIP001 	public:
//STRIP001 		// no bit fields at all (want to pass the addresses to the OConfigurationValueContainer)
//STRIP001 		::com::sun::star::uno::Sequence< ::rtl::OUString >
//STRIP001 						aHistory;
//STRIP001 		::rtl::OUString	sSingleSearchField;
//STRIP001 
//STRIP001 		sal_Int16		nSearchForType;
//STRIP001 		sal_Int16		nPosition;
//STRIP001 		sal_Int16		nLevOther;
//STRIP001 		sal_Int16		nLevShorter;
//STRIP001 		sal_Int16		nLevLonger;
//STRIP001 
//STRIP001 		sal_Bool		bAllFields;
//STRIP001 		sal_Bool		bUseFormatter;
//STRIP001 		sal_Bool		bBackwards;
//STRIP001 		sal_Bool		bWildcard;
//STRIP001 		sal_Bool		bRegular;
//STRIP001 		sal_Bool		bApproxSearch;
//STRIP001 			// the last three are mutually exclusive
//STRIP001 
//STRIP001 		// for Levenshtein-search:
//STRIP001 		sal_Bool		bLevRelaxed;
//STRIP001 
//STRIP001 		sal_Bool		bSoundsLikeCJK;
//STRIP001 
//STRIP001 		// ......................................
//STRIP001 		FmSearchParams();
//STRIP001 
//STRIP001 		sal_Bool	isIgnoreWidthCJK( ) const;
//STRIP001 		void		setIgnoreWidthCJK( sal_Bool _bIgnore );
//STRIP001 
//STRIP001 		sal_Int32	getTransliterationFlags( ) const { return nTransliterationFlags; }
//STRIP001 		void		setTransliterationFlags( sal_Int32 _nFlags ) { nTransliterationFlags = _nFlags; }
//STRIP001 
//STRIP001 		sal_Bool	isCaseSensitive( ) const;
//STRIP001 		void		setCaseSensitive( sal_Bool _bCase );
//STRIP001 	};

	// ===================================================================================================
	// = class FmSearchConfigItem - ein ConfigItem, dass sich Suchparameter merkt
	// ===================================================================================================

//STRIP001 	class FmSearchConfigItem
//STRIP001 				:protected	FmSearchParams
//STRIP001 				,public		::utl::OConfigurationValueContainer
//STRIP001 				// order matters!
//STRIP001 	{
//STRIP001 	private:
//STRIP001 		::osl::Mutex	m_aMutex;
//STRIP001 
//STRIP001 		// wrapper properties:
//STRIP001 		// some of the members of FmSearchParams are must be translated to be stored in the configuration
//STRIP001 		::rtl::OUString		m_sSearchForType;
//STRIP001 		::rtl::OUString		m_sSearchPosition;
//STRIP001 
//STRIP001 		sal_Bool			m_bIsMatchCase;
//STRIP001 		sal_Bool			m_bIsMatchFullHalfWidthForms;
//STRIP001 		sal_Bool			m_bIsMatchHiraganaKatakana;
//STRIP001 		sal_Bool			m_bIsMatchContractions;
//STRIP001 		sal_Bool			m_bIsMatchMinusDashCho_on;
//STRIP001 		sal_Bool			m_bIsMatchRepeatCharMarks;
//STRIP001 		sal_Bool			m_bIsMatchVariantFormKanji;
//STRIP001 		sal_Bool			m_bIsMatchOldKanaForms;
//STRIP001 		sal_Bool			m_bIsMatch_DiZi_DuZu;
//STRIP001 		sal_Bool			m_bIsMatch_BaVa_HaFa;
//STRIP001 		sal_Bool			m_bIsMatch_TsiThiChi_DhiZi;
//STRIP001 		sal_Bool			m_bIsMatch_HyuIyu_ByuVyu;
//STRIP001 		sal_Bool			m_bIsMatch_SeShe_ZeJe;
//STRIP001 		sal_Bool			m_bIsMatch_IaIya;
//STRIP001 		sal_Bool			m_bIsMatch_KiKu;
//STRIP001 		sal_Bool			m_bIsIgnorePunctuation;
//STRIP001 		sal_Bool			m_bIsIgnoreWhitespace;
//STRIP001 		sal_Bool			m_bIsIgnoreProlongedSoundMark;
//STRIP001 		sal_Bool			m_bIsIgnoreMiddleDot;
//STRIP001 
//STRIP001 	public:
//STRIP001 		FmSearchConfigItem();
//STRIP001 		~FmSearchConfigItem();
//STRIP001 
//STRIP001 		const FmSearchParams&	getParams( ) const;
//STRIP001 		void					setParams( const FmSearchParams& _rParams );
//STRIP001 
//STRIP001 	private:
//STRIP001 		void	implTranslateFromConfig( );
//STRIP001 		void	implTranslateToConfig( );
//STRIP001 	};

//........................................................................
}	// namespace svxform
//........................................................................

// ===================================================================================================

}//end of namespace binfilter
#endif // _FMSRCCF_HXX_

