/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: conttree.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 05:26:19 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _CONTTREE_HXX
#define _CONTTREE_HXX

// auto strip #ifndef _SVTREEBOX_HXX
// auto strip #include <svtools/svtreebx.hxx>
// auto strip #endif

// auto strip #ifndef _SWCONT_HXX
// auto strip #include "swcont.hxx"
// auto strip #endif
class Menu; 
class ToolBox; 

namespace binfilter {

class SwWrtShell;
class SwContentArr;
class SwContentType;
class SwNavigationPI;
class SwFmtFld;
class SwTxtINetFmt;
class SwNavigationConfig;
class SwDocShell;

#define EDIT_MODE_EDIT			0
#define EDIT_MODE_UPD_IDX   	1
#define EDIT_MODE_RMV_IDX   	2
#define EDIT_UNPROTECT_TABLE 	3
#define EDIT_MODE_DELETE		4
#define EDIT_MODE_RENAME		5

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

//STRIP001 class SwContentTree : public SvTreeListBox
//STRIP001 {
//STRIP001 	ImageList			aEntryImages;
//STRIP001 	String				sSpace;
//STRIP001 	AutoTimer			aUpdTimer;
//STRIP001 
//STRIP001 	SwContentType*		aActiveContentArr[CONTENT_TYPE_MAX];
//STRIP001 	SwContentType*		aHiddenContentArr[CONTENT_TYPE_MAX];
//STRIP001 	String				aContextStrings[CONTEXT_COUNT + 1];
//STRIP001 	String              sRemoveIdx;
//STRIP001 	String              sUpdateIdx;
//STRIP001 	String              sUnprotTbl;
//STRIP001 	String 				sRename;
//STRIP001 	String				sReadonlyIdx;
//STRIP001 	String				sInvisible;
//STRIP001 
//STRIP001 	SwWrtShell* 		pHiddenShell;	// gedropptes Doc
//STRIP001 	SwWrtShell* 		pActiveShell;   // die aktive oder eine konst. offene View
//STRIP001 	SwNavigationConfig*	pConfig;
//STRIP001 
//STRIP001 	USHORT				nActiveBlock;
//STRIP001 	USHORT				nHiddenBlock;
//STRIP001 	USHORT 				nRootType;
//STRIP001 	USHORT				nLastSelType;
//STRIP001 	BYTE				nOutlineLevel;
//STRIP001 
//STRIP001 	BOOL				bIsActive 			:1;
//STRIP001 	BOOL				bIsConstant 		:1;
//STRIP001 	BOOL 				bIsHidden			:1;
//STRIP001 	BOOL				bDocChgdInDragging  :1;
//STRIP001 	BOOL 				bIsInternalDrag 	:1;
//STRIP001 	BOOL				bIsRoot	  			:1;
//STRIP001 	BOOL				bIsIdleClear		:1;
//STRIP001 	BOOL				bIsLastReadOnly		:1;
//STRIP001 	BOOL				bIsOutlineMoveable	:1;
//STRIP001 	BOOL				bViewHasChanged  	:1;
//STRIP001 	BOOL				bIsImageListInitialized : 1;
//STRIP001 
//STRIP001 	static BOOL			bIsInDrag;

//STRIP001 	void 				FindActiveTypeAndRemoveUserData();

//STRIP001 protected:
//STRIP001 	virtual void	Command( const CommandEvent& rCEvt );
//STRIP001 	virtual void	RequestHelp( const HelpEvent& rHEvt );
//STRIP001 	virtual void 	InitEntry(SvLBoxEntry*,const XubString&,const Image&,const Image&);
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );

//STRIP001 	SwNavigationPI* GetParentWindow(){return
//STRIP001 						(SwNavigationPI*)Window::GetParent();}

//STRIP001 	virtual void 	StartDrag( sal_Int8 nAction, const Point& rPosPixel );
//STRIP001 	virtual void 	DragFinished( sal_Int8 );
//STRIP001 	virtual sal_Int8 AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	virtual sal_Int8 ExecuteDrop( const ExecuteDropEvent& rEvt );

//STRIP001 	sal_Bool 		FillTransferData( TransferDataContainer& rTransfer,
//STRIP001 											sal_Int8& rDragMode );
//STRIP001 	BOOL			HasContentChanged();

//STRIP001 	virtual DragDropMode NotifyStartDrag( TransferDataContainer& rData,
//STRIP001 										SvLBoxEntry* );
//STRIP001 	virtual BOOL    NotifyAcceptDrop( SvLBoxEntry* );

//STRIP001 	virtual BOOL    NotifyMoving(   SvLBoxEntry*  pTarget,
//STRIP001 									SvLBoxEntry*  pEntry,
//STRIP001 									SvLBoxEntry*& rpNewParent,
//STRIP001 									ULONG&        rNewChildPos
//STRIP001 								);
//STRIP001 	virtual BOOL    NotifyCopying(  SvLBoxEntry*  pTarget,
//STRIP001 									SvLBoxEntry*  pEntry,
//STRIP001 									SvLBoxEntry*& rpNewParent,
//STRIP001 									ULONG&        rNewChildPos
//STRIP001 								);
//STRIP001 	virtual void    MouseButtonDown( const MouseEvent& rMEvt );

//STRIP001 	void			EditEntry(SvLBoxEntry* pEntry, BYTE nMode = EDIT_MODE_EDIT);
//STRIP001 	void			GotoContent(SwContent* pCnt);
//STRIP001 	static void 	SetInDrag(BOOL bSet) {bIsInDrag = bSet;}

//STRIP001 public:
//STRIP001 	SwContentTree(Window* pParent, const ResId& rResId);
//STRIP001 	~SwContentTree();

//STRIP001 	BOOL			ToggleToRoot();
//STRIP001 	BOOL 			IsRoot() const {return bIsRoot;}
//STRIP001 	USHORT 			GetRootType() const {return nRootType;}
//STRIP001 	void 			SetRootType(USHORT nType);
//STRIP001 	void 			Display( BOOL bActiveView );
//STRIP001 	void			Clear();
//STRIP001 	void 			SetHiddenShell(SwWrtShell* pSh);
//STRIP001 	void 			ShowHiddenShell();
//STRIP001 	void			ShowActualView();
//STRIP001 	void 			SetActiveShell(SwWrtShell* pSh);
//STRIP001 	void			SetConstantShell(SwWrtShell* pSh);

//STRIP001 	SwWrtShell* 	GetWrtShell()
//STRIP001 						{return bIsActive||bIsConstant ?
//STRIP001 									pActiveShell :
//STRIP001 										pHiddenShell;}

//STRIP001 	static BOOL 	IsInDrag() {return bIsInDrag;}
//STRIP001 	BOOL			IsInternalDrag() const {return bIsInternalDrag != 0;}

//STRIP001 	USHORT			GetActiveBlock() const {return nActiveBlock;}

//STRIP001 	BYTE 			GetOutlineLevel()const {return nOutlineLevel;}
//STRIP001 	void			SetOutlineLevel(BYTE nSet);
//STRIP001 	BOOL			Expand( SvLBoxEntry* pParent );
//STRIP001 	BOOL			Collapse( SvLBoxEntry* pParent );
//STRIP001 	void 			ExecCommand(USHORT nCmd, BOOL bModifier);
//STRIP001 	void			Show();
//STRIP001 	void			Hide();

//STRIP001 	BOOL			IsConstantView() {return bIsConstant;}
//STRIP001 	BOOL			IsActiveView()	 {return bIsActive;}
//STRIP001 	BOOL 			IsHiddenView()	 {return bIsHidden;}

//STRIP001 	const SwWrtShell* 	GetActiveWrtShell() {return pActiveShell;}
//STRIP001 	SwWrtShell*			GetHiddenWrtShell() {return pHiddenShell;}

//STRIP001 	DECL_LINK( ContentDoubleClickHdl, SwContentTree * );
//STRIP001 	DECL_LINK( PopupHdl, Menu* );
//STRIP001 	DECL_LINK( TimerUpdate, Timer * );

//STRIP001 	virtual long    GetTabPos( SvLBoxEntry*, SvLBoxTab* );
//STRIP001 	virtual void	RequestingChilds( SvLBoxEntry* pParent );
//STRIP001 	virtual void    GetFocus();
//STRIP001 	virtual void    KeyInput(const KeyEvent& rKEvt);
//STRIP001 	virtual BOOL	Select( SvLBoxEntry* pEntry, BOOL bSelect=TRUE );
//STRIP001 };


//----------------------------------------------------------------------------
// TreeListBox fuer Globaldokumente
//----------------------------------------------------------------------------

class SwGlblDocContents;
class SwGlblDocContent;

//STRIP001 class SwLBoxString : public SvLBoxString
//STRIP001 {
//STRIP001 public:

//STRIP001 	SwLBoxString( SvLBoxEntry* pEntry, USHORT nFlags,
//STRIP001 		const String& rStr ) : SvLBoxString(pEntry,nFlags,rStr)
//STRIP001 	{
//STRIP001 	}

//STRIP001 	virtual void Paint( const Point& rPos, SvLBox& rDev, USHORT nFlags,
//STRIP001 		SvLBoxEntry* pEntry);
//STRIP001 };

//STRIP001 class SwGlobalTree : public SvTreeListBox
//STRIP001 {
//STRIP001 	AutoTimer			aUpdateTimer;
//STRIP001 	String				aContextStrings[GLOBAL_CONTEXT_COUNT];
//STRIP001 
//STRIP001 	ImageList			aEntryImages;
//STRIP001 
//STRIP001 	SwWrtShell* 		pActiveShell;   //
//STRIP001 	SvLBoxEntry*		pEmphasisEntry; // Drag'n Drop-Emphasis
//STRIP001 	SvLBoxEntry*		pDDSource;		// Quelle beim DnD
//STRIP001 	SwGlblDocContents*	pSwGlblDocContents; // Array mit sortierten Inhalten
//STRIP001 
//STRIP001 	BOOL 				bIsInternalDrag 	:1;
//STRIP001 	BOOL 				bLastEntryEmphasis 	:1; // Drag'n Drop
//STRIP001 	BOOL				bIsImageListInitialized : 1;
//STRIP001 
//STRIP001 	static const SfxObjectShell* pShowShell;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual sal_Int8 AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	virtual sal_Int8 ExecuteDrop( const ExecuteDropEvent& rEvt );
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );

//STRIP001 	virtual void	Command( const CommandEvent& rCEvt );
//STRIP001 	virtual void	RequestHelp( const HelpEvent& rHEvt );

//STRIP001 	virtual long    GetTabPos( SvLBoxEntry*, SvLBoxTab* );
//STRIP001 	virtual BOOL    NotifyMoving(   SvLBoxEntry*  pTarget,
//STRIP001 									SvLBoxEntry*  pEntry,
//STRIP001 									SvLBoxEntry*& rpNewParent,
//STRIP001 									ULONG&        rNewChildPos
//STRIP001 								);
//STRIP001 	virtual BOOL    NotifyCopying(  SvLBoxEntry*  pTarget,
//STRIP001 									SvLBoxEntry*  pEntry,
//STRIP001 									SvLBoxEntry*& rpNewParent,
//STRIP001 									ULONG&        rNewChildPos
//STRIP001 								);

//STRIP001 	virtual void 	StartDrag( sal_Int8 nAction, const Point& rPosPixel );
//STRIP001 	virtual void 	DragFinished( sal_Int8 );
//STRIP001 	virtual DragDropMode NotifyStartDrag( TransferDataContainer& rData,
//STRIP001 										SvLBoxEntry* );
//STRIP001 	virtual BOOL    NotifyAcceptDrop( SvLBoxEntry* );

//STRIP001 	virtual void    MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void    KeyInput(const KeyEvent& rKEvt);
//STRIP001 	virtual void    GetFocus();
//STRIP001 	virtual void	SelectHdl();
//STRIP001 	virtual void	DeselectHdl();
//STRIP001 	virtual void InitEntry(SvLBoxEntry*,const XubString&,const Image&,const Image&);

//STRIP001 	void			Clear();

//STRIP001 	DECL_LINK( 		PopupHdl, Menu* );
//STRIP001 	DECL_LINK( 		Timeout, Timer* );
//STRIP001 	DECL_LINK( 		DoubleClickHdl, SwGlobalTree * );

//STRIP001 	BOOL			IsInternalDrag() const {return bIsInternalDrag != 0;}
//STRIP001 	SwNavigationPI* GetParentWindow()
//STRIP001 						{ return (SwNavigationPI*)Window::GetParent(); }

//STRIP001 	void 			OpenDoc(const SwGlblDocContent*);
//STRIP001 	void 			GotoContent(const SwGlblDocContent*);
//STRIP001 	USHORT			GetEnableFlags() const;

//STRIP001 	static const SfxObjectShell* 	GetShowShell() {return pShowShell;}
//STRIP001 	static void 	SetShowShell(const SfxObjectShell*pSet) {pShowShell = pSet;}
//STRIP001 	DECL_STATIC_LINK(SwGlobalTree, ShowFrameHdl, SwGlobalTree*);

//STRIP001 public:
//STRIP001 	SwGlobalTree(Window* pParent, const ResId& rResId);
//STRIP001 	virtual ~SwGlobalTree();

//STRIP001 	void 				TbxMenuHdl(USHORT nTbxId, ToolBox* pBox);
//STRIP001 	void 				InsertRegion( const SwGlblDocContent* pCont,
//STRIP001 										const String* pFileName = 0 );
//STRIP001 	void 				EditContent(const SwGlblDocContent* pCont );
//STRIP001 	void				Show();
//STRIP001 	void				Hide();

//STRIP001 	void 				ExecCommand(USHORT nCmd);

//STRIP001 	void 				Display(BOOL bOnlyUpdateUserData = FALSE);
//STRIP001 	BOOL 				Update(BOOL bHard = FALSE);
//STRIP001 };



} //namespace binfilter
#endif


