/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sw_wizcfg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 07:15:32 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/



#pragma hdrstop

#ifndef _WIZCFG_HXX
#include <wizcfg.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _WIZAG_HXX
#include <wizag.hxx>
#endif
#ifndef _WIZDOKU_HXX
#include <wizdoku.hxx>
#endif
namespace binfilter {

using namespace rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;

#define C2U(cChar) OUString::createFromAscii(cChar)
#define C2S(cChar) String::CreateFromAscii(cChar)
const char* cAgendaList = "AgendaTopics/AgendaList";
/* -----------------------------29.05.01 08:51--------------------------------

 ---------------------------------------------------------------------------*/
void lcl_ExpandPlaceHolder(OUString& rPropertyName)
{
    static const char cTemplate[] = "Template/";
    static const char cLogo[] = "Logo/";
    static const char cSender[] = "Sender/";
    static const char cRecipient[] = "Recipient/";
    static const char cElements[] = "Elements/";
    static const char cSave[] = "Save/";
    static const char cHeader[] = "Header/";
    static const char cFooter[] = "Footer/";
    static const char cPrint[] = "Print/";
    static const char cElementsElement[] = "Elements/Element";
    static const char cLogoAlignPos[] = "Logo/Alignment/Position/";
    static const char cSenderAlignPos[] = "Sender/Alignment/Position/";
    static const char cRecipientAlignPos[] = "Recipient/Alignment/Position/";
    sal_Int32 nToken = rPropertyName.getStr()[0];
    nToken -= '0';
    const char* cReplace = 0;
    switch(nToken)
    {
        case 0 : cReplace = cTemplate; break;
        case 1 : cReplace = cLogo; break;
        case 2 : cReplace = cSender; break;
        case 3 : cReplace = cRecipient; break;
        case 4 : cReplace = cElements; break;
        case 5 : cReplace = cSave; break;
        case 6 : cReplace = cHeader; break;
        case 7 : cReplace = cFooter; break;
        case 8 : cReplace = cPrint; break;
        case 9 : cReplace = cElementsElement; break;
        case 49: cReplace = cLogoAlignPos; break; //'a'
        case 50: cReplace = cSenderAlignPos; break; //'b'
        case 51: cReplace = cRecipientAlignPos; break; // 'c'
    }
    if(cReplace)
    {
        String sTmp(rPropertyName);
        sTmp.Erase(0, 1);
        sTmp.InsertAscii(cReplace, 0);
        rPropertyName = sTmp;
    }

}
/* -----------------------------25.09.00 09:31--------------------------------

 ---------------------------------------------------------------------------*/
void SwWizardCfgDocInfo::ReadDocInfo(WizardDokuDlg& rDoc)
{
	rDoc.pD_List_InfTit->SelectEntry(sSaveDocInfoTitle);
	rDoc.pD_List_InfTem->SelectEntry(sSaveDocInfoSubject);
	rDoc.pD_Edit_VorNam->SetText(sSaveTemplateName);
	rDoc.pD_Edit_VorInf->SetText(sSaveTemplateInfo);
	rDoc.pD_CBox_AutoFN->Check(bSaveAutoDocName);
	rDoc.pD_Edit_AutoFN->SetText(sSaveAutoPrefix);
	rDoc.pD_Text_Folder->SetText(sSaveAutoPath);
}
/* -----------------------------25.09.00 09:38--------------------------------

 ---------------------------------------------------------------------------*/
void SwWizardCfgDocInfo::WriteDocInfo(const WizardDokuDlg& rDoc)
{
	sSaveDocInfoTitle = 	rDoc.pD_List_InfTit->GetSelectEntry();
	sSaveDocInfoSubject = 	rDoc.pD_List_InfTem->GetSelectEntry();
	sSaveTemplateName = 	rDoc.pD_Edit_VorNam->GetText();
	sSaveTemplateInfo = 	rDoc.pD_Edit_VorInf->GetText();
	bSaveAutoDocName = 		rDoc.pD_CBox_AutoFN->IsChecked();
	sSaveAutoPrefix = 		rDoc.pD_Edit_AutoFN->GetText();
	sSaveAutoPath  = 		rDoc.pD_Text_Folder->GetText();
};
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
Sequence<OUString> SwAgendaWizardCfg::GetPropertyNames()
{
	static const char* aPropNames[] =
	{
        "0Style/PreferredStyle",            // 0
        "1GraphicFile/Name",  // 1
        "1GraphicFile/Filter",// 2
        "1GraphicFile/AsLink",  // 3
        "4Occasion",            // 4
        "AgendaTopics/Number",  // 5
        "5AutoPrefix",          // 6
        "5AutoDocName",         // 7
        "5AutoPath",            // 8
        "4Notes",               // 9
        "4Date",                // 10
        "4Convened",            // 11
        "4Experts",             // 12
        "4Guests",              // 13
        "5DocInfoSubject",      // 14
        "5DocInfoTitle",        // 15
        "4Presiding",           // 16
        "4BringAlong",          // 17
        "4Postprocessing",      // 18
        "4Location",            // 19
        "4Minutes",             // 20
        "4UseMinutes",          // 21
        "4Participants",        // 22
        "4Title",               // 23
        "1Visible",             // 24
        "4Time",                // 25
        "4Prepare",             // 26
        "5TemplateInfo",        // 27
        "5TemplateName"         // 28
	};
    const int nCount = sizeof( aPropNames ) / sizeof( const char* );
	Sequence<OUString> aNames(nCount);
	OUString* pNames = aNames.getArray();
	for(int i = 0; i < nCount; i++)
	{
		pNames[i] = OUString::createFromAscii(aPropNames[i]);
        lcl_ExpandPlaceHolder(pNames[i]);
	}
	return aNames;
}
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
SwAgendaWizardCfg::SwAgendaWizardCfg() :
	ConfigItem( C2U("Office.Writer/Wizard/Agenda")),
	pAgendaArr(0),
	nStyle(0),
	bOccasion(false),
	nNumber(0),
	bNotes(false),
	nDate(0),
	bConvened(false),
	bExperts(false),
	bGuests(false),
	bPresiding(false),
	bBringAlong(false),
	bPostprocessing(false),
	bMinutes(false),
    bUseMinutes(true),
	bParticipants(false),
	bLogoVisible(false),
    bLogoGraphicAsLink(false),
	nTime(0),
	bPrepare(false)
{
	Sequence<OUString> aNames = GetPropertyNames();
	Sequence<Any> aValues = GetProperties(aNames);
	const Any* pValues = aValues.getConstArray();
	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
	if(aValues.getLength() == aNames.getLength())
	{
		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
		{
			if(pValues[nProp].hasValue())
			{
				SetValuesRead();
				switch(nProp)
				{
					case 0: pValues[nProp] >>= nStyle; break;
					case 1: pValues[nProp] >>= sLogoGrapicName; break;
					case 2: pValues[nProp] >>= sLogoGrapicFilter; break;
                    case 3: bLogoGraphicAsLink = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 4: bOccasion = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 5: pValues[nProp] >>= nNumber; break;
                    case 6: pValues[nProp] >>= sSaveAutoPrefix; break;
                    case 7: bSaveAutoDocName = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 8: pValues[nProp] >>= sSaveAutoPath; break;
                    case 9: bNotes = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 10: pValues[nProp] >>= nDate; break;
                    case 11:bConvened = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 12:bExperts = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 13:bGuests = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 14:pValues[nProp] >>= sSaveDocInfoSubject; break;
                    case 15:pValues[nProp] >>= sSaveDocInfoTitle; break;
                    case 16:bPresiding = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 17:bBringAlong = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 18:bPostprocessing = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 19:pValues[nProp] >>= sLocation; break;
                    case 20:bMinutes = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 21:bUseMinutes = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 22:bParticipants = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 23:pValues[nProp] >>= sTitle; break;
                    case 24:bLogoVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 25:pValues[nProp] >>= nTime; break;
                    case 26:bPrepare = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 27:pValues[nProp] >>= sSaveTemplateInfo; break;
                    case 28:pValues[nProp] >>= sSaveTemplateName; break;
				}
			}
		}
	}
}
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
SwAgendaWizardCfg::~SwAgendaWizardCfg()
{
	delete pAgendaArr;
}
/* -----------------------------14.09.00 12:58--------------------------------

 ---------------------------------------------------------------------------*/
void	SwAgendaWizardCfg::Commit()
{
	Sequence<OUString> aNames = GetPropertyNames();

	OUString* pNames = aNames.getArray();
	Sequence<Any> aValues(aNames.getLength());
	Any* pValues = aValues.getArray();

	const Type& rType = ::getBooleanCppuType();
	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
	{
		switch(nProp)
		{
			case 0: pValues[nProp] <<= nStyle; break;
			case 1: pValues[nProp] <<= sLogoGrapicName; break;
			case 2: pValues[nProp] <<= sLogoGrapicFilter; break;
            case 3 : pValues[nProp].setValue(&bLogoGraphicAsLink, rType); break;
            case 4 : pValues[nProp].setValue(&bOccasion, rType); break;
            case 5 : pValues[nProp] <<= nNumber; break;
            case 6 : pValues[nProp] <<= sSaveAutoPrefix; break;
            case 7 : pValues[nProp].setValue(&bSaveAutoDocName, rType); break;
            case 8 : pValues[nProp] <<= sSaveAutoPath; break;
            case 9 : pValues[nProp].setValue(&bNotes, rType); break;
            case 10: pValues[nProp] <<= nDate; break;
            case 11:pValues[nProp].setValue(&bConvened, rType); break;
            case 12:pValues[nProp].setValue(&bExperts, rType); break;
            case 13:pValues[nProp].setValue(&bGuests, rType); break;
            case 14:pValues[nProp] <<= sSaveDocInfoSubject; break;
            case 15:pValues[nProp] <<= sSaveDocInfoTitle; break;
            case 16:pValues[nProp].setValue(&bPresiding, rType); break;
            case 17:pValues[nProp].setValue(&bBringAlong, rType); break;
            case 18:pValues[nProp].setValue(&bPostprocessing, rType); break;
            case 19:pValues[nProp] <<= sLocation; break;
            case 20:pValues[nProp].setValue(&bMinutes, rType); break;
            case 21:pValues[nProp].setValue(&bUseMinutes, rType); break;
            case 22:pValues[nProp].setValue(&bParticipants, rType); break;
            case 23:pValues[nProp] <<= sTitle; break;
            case 24:pValues[nProp].setValue(&bLogoVisible, rType); break;
            case 25:pValues[nProp] <<= nTime;break;
            case 26:pValues[nProp].setValue(&bPrepare, rType); break;
            case 27:pValues[nProp] <<= sSaveTemplateInfo; break;
            case 28:pValues[nProp] <<= sSaveTemplateName; break;
		}
	}
	PutProperties(aNames, aValues);
	if(pAgendaArr)
	{
		OUString sAuthorSuffix(C2U("/Author"));
		OUString sDurationSuffix(C2U("/Duration"));
		OUString sTopicSuffix(C2U("/Topic"));
		Sequence< PropertyValue > aValues(pAgendaArr->GetAnz() * 3);
		PropertyValue* pValues = aValues.getArray();

		sal_Int32 nIndex = 0;
		for(sal_Int32 i = 0; i < pAgendaArr->GetAnz(); i++)
		{
			AgendaRec aRec;
			pAgendaArr->GetRec(i,aRec);

			OUString sPrefix(C2U(cAgendaList));
			sPrefix += C2U("/_");
			sPrefix += OUString::valueOf(i);
			pValues[nIndex].Name	= sPrefix;
			pValues[nIndex].Name	+= sAuthorSuffix;
			pValues[nIndex++].Value <<= OUString(aRec.aName);
			pValues[nIndex].Name    = sPrefix;
			pValues[nIndex].Name    += sDurationSuffix;
			pValues[nIndex++].Value <<= aRec.nZeit;
			pValues[nIndex].Name	= sPrefix;
			pValues[nIndex].Name    += sTopicSuffix;
			pValues[nIndex++].Value <<= OUString(aRec.aThem);
		}
		ReplaceSetProperties( C2U(cAgendaList), aValues);
	}
}
/* -----------------------------15.09.00 16:50--------------------------------

 ---------------------------------------------------------------------------*/
AgendaArray&	SwAgendaWizardCfg::GetAgendaArray()
{
	if(!pAgendaArr)
	{
		pAgendaArr = new AgendaArray;
		Sequence<OUString> aListNames = GetNodeNames(C2U(cAgendaList));
		if(aListNames.getLength())
		{
			const OUString* pListNames = aListNames.getConstArray();
			Sequence< ::rtl::OUString > aNames(aListNames.getLength() * 3);
			OUString* pNames = aNames.getArray();
			const OUString sSlash('/');
			sal_Int32 nIndex = 0;
			for(sal_Int32 i = 0; i < aListNames.getLength(); i++)
			{
				OUString sPrefix(C2U(cAgendaList));
				sPrefix += sSlash;
				sPrefix += pListNames[i];
				sPrefix += sSlash;
				pNames[nIndex] = sPrefix;
				pNames[nIndex++] += C2U("Author");
				pNames[nIndex] = sPrefix;
				pNames[nIndex++] += C2U("Duration");
				pNames[nIndex] = sPrefix;
				pNames[nIndex++] += C2U("Topic");
			}
			Sequence< Any> aProperties = GetProperties(aNames);
			const Any* pProperties = aProperties.getConstArray();
			if(aProperties.getLength() == aNames.getLength())
			{
				nIndex = 0;
				for(sal_Int32 i = 0; i < aListNames.getLength(); i++)
				{
					OUString sAuthor;
					sal_Int32 nDuration;
					OUString sTopic;
					pProperties[nIndex++] >>= sAuthor;
					pProperties[nIndex++] >>= nDuration;
					pProperties[nIndex++] >>= sTopic;
					pAgendaArr->SetThm(i, sTopic);
					pAgendaArr->SetNam(i, sAuthor);
					pAgendaArr->SetTim(i, nDuration);
				}
			}
		}
	}
	return *pAgendaArr;
}
/******************************************************************************

******************************************************************************/
Sequence<OUString> SwLetterWizardCfg::GetPropertyNames()
{
	static const char* aPropNames[] =
	{
        "0Type",  //                                    0
        "0Style/PreferredStyle",  //            1
        "1Visible",  //                                 2
        "1IsGraphic",  //                               3
        "1Text",  //                                    4
        "1GraphicFile/Name",  //                        5
        "1GraphicFile/Filter",  //                      6
        "1GraphicFile/AsLink",  //                      7
        "1Position/X",  //                              8
        "1Position/Y",  //                              9
        "1Size/Width",  //                              10
        "1Size/Height",  //                             11
        "1Alignment/Type/Position",  //                 12
        "aLeft",  //                                    13
        "aRight",  //                                   14
        "aTop",  //                                     15
        "aBottom",  //                                  16
        "2Show",  //                                    17
        "2Content",  //                                 18
        "2Repeat",  //                                  19
        "2Position/X",  //                              20
        "2Position/Y",  //                              21
        "2Size/Width",  //                              22
        "2Size/Height",  //                             23
        "2Alignment/Type/Position",  //                 24
        "bLeft",  //                                    25
        "bRight",  //                                   26
        "bTop",  //                                     27
        "bBottom",  //                                  28
        "3Database",  //                                29
        "3Content",  //                                 30
        "3Salutation",  //                              31
        "3SalutationField",  //                         32
        "3Position/X",  //                              33
        "3Position/Y",  //                              34
        "3Size/Width",  //                              35
        "3Size/Height",  //                             36
        "3Alignment/Type/Position",  //                 37
        "cLeft",  //                                    38
        "cRight",  //                                   39
        "cTop",  //                                     40
        "cBottom",  //                                  41
        "91/Text/Visible",  //                          42
        "91/Text/Content",  //                          43
        "92/Text/Visible",  //                          44
        "92/Text/Content",  //                          45
        "93/Text/Visible",  //                          46
        "93/Text/Content",  //                          47
        "94/Text/Visible",  //                          48
        "94/Text/Content",  //                          49
        "4Date/Value/Visible",  //                      50
        "4Date/Value/Content",  //                      51
        "4Subject/Text/Visible",  //                    52
        "4Subject/Text/Content",  //                    53
        "4Copy",  //                                    54
        "4Enclosure",  //                               55
        "4PageNumber/Visible",  //                      56
        "4PageNumber/TextBefore",  //                   57
        "4PageNumber/Format",  //                       58
        "4PageNumber/TotalPageCount/Visible",//         59
        "4PageNumber/TotalPageCount/TextBefore",//      60
        "6FromTop",  //                                 61
        "6FromText",  //                                62
        "6Sender/Visible",  //                          63
        "6Sender/Size/Width",  //                       64
        "6Sender/Size/Height",  //                      65
        "6Sender/Alignment/Position",  //               66
        "6Logo/Visible",  //                            67
        "6Logo/Size/Width",  //                         68
        "6Logo/Size/Height",  //                        69
        "6Logo/Alignment/Position",  //                 70
        "7OnPage1/Enable",  //                          71
        "7OnPage1/Separator",  //                       72
        "7OnPage1/Text",  //                            73
        "7OnPage1/FromBottom",  //                      74
        "7OnPage1/FromText",  //                        75
        "7OnContinuationPages/Enable",  //              76
        "7OnContinuationPages/FromBottom",  //          77
        "7OnContinuationPages/FromText",  //            78
        "5DocInfoTitle",  //                            79
        "5DocInfoSubject",  //                          80
        "5TemplateName",  //                            81
        "5TemplateInfo",  //                            82
        "5AutoDocName",  //                             83
        "5AutoPrefix",  //                              84
        "5AutoPath",  //                                85
        "8Sender",  //                                  86
        "8Logo",  //                                    87
        "8Printer",  //                                 88
        "8Tray/Page1",  //                              89
        "8Tray/ContinuationPage",  //                   90
        "PageMargin/Left",//                            91
        "PageMargin/Right", //                          92
        "3DataTable",  //                               93
    };
    const int nCount = sizeof( aPropNames ) / sizeof( const char* );
	Sequence<OUString> aNames(nCount);
	OUString* pNames = aNames.getArray();
	for(int i = 0; i < nCount; i++)
	{
		pNames[i] = OUString::createFromAscii(aPropNames[i]);
        lcl_ExpandPlaceHolder(pNames[i]);
    }
	return aNames;
}
/* -----------------------------14.09.00 13:23--------------------------------

 ---------------------------------------------------------------------------*/
SwLetterWizardCfg::SwLetterWizardCfg() :
	ConfigItem( C2U("Office.Writer/Wizard/Letter")),
	nPageMarginLeft(0),
	nPageMarginRight(0),
	bTemplateType(0),
	nTemplateStyleTypePreferredStyle(0),
	bLogoVisible(0),
	bLogoIsGraphic(0),
    bLogoFileTypeAsLink(false),
	nLogoPositionXYTypeX(0),
	nLogoPositionXYTypeY(0),
	nLogoSizeTypeWidth(0),
	nLogoSizeTypeHeight(0),
	nLogoAlignmentAlignmentTypePosition(0),
	nLogoAlignmentPositionTypeLeft(0),
	nLogoAlignmentPositionTypeRight(0),
	nLogoAlignmentPositionTypeTop(0),
	nLogoAlignmentPositionTypeBottom(0),
	bSenderShow(0),
	bSenderRepeat(0),
	nSenderPositionXYTypeX(0),
	nSenderPositionXYTypeY(0),
	nSenderSizeTypeWidth(0),
	nSenderSizeTypeHeight(0),
	nSenderAlignmentTypePosition(0),
	nSenderPositionTypeLeft(0),
	nSenderPositionTypeRight(0),
	nSenderPositionTypeTop(0),
	nSenderPositionTypeBottom(0),
	nRecipientPositionXYTypeX(0),
	nRecipientPositionXYTypeY(0),
	nRecipientSizeTypeWidth(0),
	nRecipientSizeTypeHeight(0),
	nRecipientAlignmentAlignmentTypePosition(0),
	nRecipientAlignmentPositionTypeLeft(0),
	nRecipientAlignmentPositionTypeRight(0),
	nRecipientAlignmentPositionTypeTop(0),
	nRecipientAlignmentPositionTypeBottom(0),
	bElementsElement1TextElementTypeVisible(0),
	bElementsElement2TextElementTypeVisible(0),
	bElementsElement3TextElementTypeVisible(0),
	bElementsElement4TextElementTypeVisible(0),
	bElementsDateIntElementTypeVisible(0),
	nElementsDateIntElementTypeContent(0),
	bElementsSubjectTextElementTypeVisible(0),
	bElementsCopy(0),
	bElementsEnclosure(0),
	bElementsPageNumberVisible(0),
	nElementsPageNumberFormat(0),
	bElementsPageNumberTotalPageCountVisible(0),
	nHeaderFromTop(0),
	nHeaderFromText(0),
	bHeaderSenderVisible(0),
	nHeaderSenderSizeTypeWidth(0),
	nHeaderSenderSizeTypeHeight(0),
	nHeaderSenderAlignmentTypePosition(0),
	bHeaderLogoVisible(0),
	nHeaderLogoSizeTypeWidth(0),
	nHeaderLogoSizeTypeHeight(0),
	nHeaderLogoAlignmentTypePosition(0),
	bFooterOnPage1Enable(0),
	bFooterOnPage1Separator(0),
	nFooterOnPage1FromBottom(0),
	nFooterOnPage1FromText(0),
	bFooterOnContinuationPagesEnable(0),
	nFooterOnContinuationPagesFromBottom(0),
	nFooterOnContinuationPagesFromText(0),
	nPrintSender(0),
	nPrintLogo(0)
{
	Sequence<OUString> aNames = GetPropertyNames();
	Sequence<Any> aValues = GetProperties(aNames);
	const Any* pValues = aValues.getConstArray();
	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
	if(aValues.getLength() == aNames.getLength())
	{
		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
		{
			if(pValues[nProp].hasValue())
			{
				SetValuesRead();
				switch(nProp)
				{
					case 0:	 bTemplateType = *(sal_Bool*)pValues[nProp].getValue();			break;
					case 1:  pValues[nProp] >>= nTemplateStyleTypePreferredStyle;            	break;
					case 2:  bLogoVisible = *(sal_Bool*)pValues[nProp].getValue();          	break;
					case 3:  bLogoIsGraphic = *(sal_Bool*)pValues[nProp].getValue();        	break;
					case 4:  pValues[nProp] >>= sLogoText;                                      break;
					case 5:  pValues[nProp] >>= sLogoFileTypeName;                              break;
					case 6:  pValues[nProp] >>= sLogoFileTypeFilter;                            break;
                    case 7 :  bLogoFileTypeAsLink = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 8 :  pValues[nProp] >>= nLogoPositionXYTypeX;                           break;
                    case 9 :  pValues[nProp] >>= nLogoPositionXYTypeY;                           break;
                    case 10:  pValues[nProp] >>= nLogoSizeTypeWidth;                             break;
                    case 11: pValues[nProp] >>= nLogoSizeTypeHeight;                            break;
                    case 12: pValues[nProp] >>= nLogoAlignmentAlignmentTypePosition;            break;
                    case 13: pValues[nProp] >>= nLogoAlignmentPositionTypeLeft;                 break;
                    case 14: pValues[nProp] >>= nLogoAlignmentPositionTypeRight;                break;
                    case 15: pValues[nProp] >>= nLogoAlignmentPositionTypeTop;                  break;
                    case 16: pValues[nProp] >>= nLogoAlignmentPositionTypeBottom;               break;
                    case 17: bSenderShow = *(sal_Bool*)pValues[nProp].getValue();                  break;
                    case 18: pValues[nProp] >>= sSenderContent;                  break;
                    case 19: bSenderRepeat = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 20: pValues[nProp] >>= nSenderPositionXYTypeX;                         break;
                    case 21: pValues[nProp] >>= nSenderPositionXYTypeY;                         break;
                    case 22: pValues[nProp] >>= nSenderSizeTypeWidth;                           break;
                    case 23: pValues[nProp] >>= nSenderSizeTypeHeight;                          break;
                    case 24: pValues[nProp] >>= nSenderAlignmentTypePosition;                   break;
                    case 25: pValues[nProp] >>= nSenderPositionTypeLeft;                        break;
                    case 26: pValues[nProp] >>= nSenderPositionTypeRight;                       break;
                    case 27: pValues[nProp] >>= nSenderPositionTypeTop;                         break;
                    case 28: pValues[nProp] >>= nSenderPositionTypeBottom;                      break;
                    case 29: pValues[nProp] >>= sRecipientDatabase;                             break;
                    case 30: pValues[nProp] >>= sRecipientContent;               break;
                    case 31: pValues[nProp] >>= sRecipientSalutation;                           break;
                    case 32: pValues[nProp] >>= sRecipientSalutationField;                      break;
                    case 33: pValues[nProp] >>= nRecipientPositionXYTypeX;                      break;
                    case 34: pValues[nProp] >>= nRecipientPositionXYTypeY;                      break;
                    case 35: pValues[nProp] >>= nRecipientSizeTypeWidth;                        break;
                    case 36: pValues[nProp] >>= nRecipientSizeTypeHeight;                       break;
                    case 37: pValues[nProp] >>= nRecipientAlignmentAlignmentTypePosition;       break;
                    case 38: pValues[nProp] >>= nRecipientAlignmentPositionTypeLeft;            break;
                    case 39: pValues[nProp] >>= nRecipientAlignmentPositionTypeRight;           break;
                    case 40: pValues[nProp] >>= nRecipientAlignmentPositionTypeTop;             break;
                    case 41: pValues[nProp] >>= nRecipientAlignmentPositionTypeBottom;          break;
                    case 42: bElementsElement1TextElementTypeVisible = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 43: pValues[nProp] >>= sElementsElement1TextElementTypeContent;        break;
                    case 44: bElementsElement2TextElementTypeVisible = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 45: pValues[nProp] >>= sElementsElement2TextElementTypeContent;        break;
                    case 46: bElementsElement3TextElementTypeVisible = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 47: pValues[nProp] >>= sElementsElement3TextElementTypeContent;        break;
                    case 48: bElementsElement4TextElementTypeVisible = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 49: pValues[nProp] >>= sElementsElement4TextElementTypeContent;        break;
                    case 50: bElementsDateIntElementTypeVisible = *(sal_Bool*)pValues[nProp].getValue();     break;
                    case 51: pValues[nProp] >>= nElementsDateIntElementTypeContent;             break;
                    case 52: bElementsSubjectTextElementTypeVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 53: pValues[nProp] >>= sElementsSubjectTextElementTypeContent;         break;
                    case 54: bElementsCopy = *(sal_Bool*)pValues[nProp].getValue();            break;
                    case 55: bElementsEnclosure = *(sal_Bool*)pValues[nProp].getValue();       break;
                    case 56: bElementsPageNumberVisible = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 57: pValues[nProp] >>= sElementsPageNumberTextBefore;                  break;
                    case 58: pValues[nProp] >>= nElementsPageNumberFormat;                      break;
                    case 59: bElementsPageNumberTotalPageCountVisible = *(sal_Bool*)pValues[nProp].getValue();break;
                    case 60: pValues[nProp] >>= sElementsPageNumberTotalPageCountTextBefore;    break;
                    case 61: pValues[nProp] >>= nHeaderFromTop;                                 break;
                    case 62: pValues[nProp] >>= nHeaderFromText;                                break;
                    case 63: bHeaderSenderVisible = *(sal_Bool*)pValues[nProp].getValue();     break;
                    case 64: pValues[nProp] >>= nHeaderSenderSizeTypeWidth;                     break;
                    case 65: pValues[nProp] >>= nHeaderSenderSizeTypeHeight;                    break;
                    case 66: pValues[nProp] >>= nHeaderSenderAlignmentTypePosition;             break;
                    case 67: bHeaderLogoVisible = *(sal_Bool*)pValues[nProp].getValue();       break;
                    case 68: pValues[nProp] >>= nHeaderLogoSizeTypeWidth;                       break;
                    case 69: pValues[nProp] >>= nHeaderLogoSizeTypeHeight;                      break;
                    case 70: pValues[nProp] >>= nHeaderLogoAlignmentTypePosition;               break;
                    case 71: bFooterOnPage1Enable = *(sal_Bool*)pValues[nProp].getValue();     break;
                    case 72: bFooterOnPage1Separator = *(sal_Bool*)pValues[nProp].getValue();  break;
                    case 73: pValues[nProp] >>= sFooterOnPage1Text;                             break;
                    case 74: pValues[nProp] >>= nFooterOnPage1FromBottom;                       break;
                    case 75: pValues[nProp] >>= nFooterOnPage1FromText;                         break;
                    case 76: bFooterOnContinuationPagesEnable = *(sal_Bool*)pValues[nProp].getValue();               break;
                    case 77: pValues[nProp] >>= nFooterOnContinuationPagesFromBottom;           break;
                    case 78: pValues[nProp] >>= nFooterOnContinuationPagesFromText;             break;
                    case 79: pValues[nProp] >>= sSaveDocInfoTitle;                              break;
                    case 80: pValues[nProp] >>= sSaveDocInfoSubject;                            break;
                    case 81: pValues[nProp] >>= sSaveTemplateName;                              break;
                    case 82: pValues[nProp] >>= sSaveTemplateInfo;                              break;
                    case 83: bSaveAutoDocName = *(sal_Bool*)pValues[nProp].getValue();      break;
                    case 84: pValues[nProp] >>= sSaveAutoPrefix;                                break;
                    case 85: pValues[nProp] >>= sSaveAutoPath;                                  break;
                    case 86: pValues[nProp] >>= nPrintSender;                                   break;
                    case 87: pValues[nProp] >>= nPrintLogo;                                     break;
                    case 88: pValues[nProp] >>= sPrintPrinter;                                  break;
                    case 89: pValues[nProp] >>= sPrintTrayPage1;                                break;
                    case 90: pValues[nProp] >>= sPrintTrayContinuationPage;                     break;
                    case 91: pValues[nProp] >>= nPageMarginLeft;break;
                    case 92: pValues[nProp] >>= nPageMarginRight;break;
                    case 93: pValues[nProp] >>= sRecipientDataTable;                             break;

				}
			}
		}
	}
}
/* -----------------------------14.09.00 13:23--------------------------------

 ---------------------------------------------------------------------------*/
SwLetterWizardCfg::~SwLetterWizardCfg()
{
}
/* -----------------------------14.09.00 13:23--------------------------------

 ---------------------------------------------------------------------------*/
void SwLetterWizardCfg::Commit()
{
	Sequence<OUString> aNames = GetPropertyNames();

	OUString* pNames = aNames.getArray();
	Sequence<Any> aValues(aNames.getLength());
	Any* pValues = aValues.getArray();

	const Type& rType = ::getBooleanCppuType();
	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
	{
		switch(nProp)
		{
			case  0:	 pValues[nProp].setValue(&bTemplateType, rType);break;
			case  1:  pValues[nProp] <<= nTemplateStyleTypePreferredStyle;            	break;
			case  2:  pValues[nProp].setValue(&bLogoVisible, rType);break;
			case  3:  pValues[nProp].setValue(&bLogoIsGraphic, rType);break;
			case  4:  pValues[nProp] <<= sLogoText;                                      break;
			case  5:  pValues[nProp] <<= sLogoFileTypeName;                              break;
			case  6:  pValues[nProp] <<= sLogoFileTypeFilter;                            break;
            case  7:   pValues[nProp].setValue(&bLogoFileTypeAsLink, rType); break;
            case  8:  pValues[nProp] <<= nLogoPositionXYTypeX;                           break;
            case  9:  pValues[nProp] <<= nLogoPositionXYTypeY;                           break;
            case 10:  pValues[nProp] <<= nLogoSizeTypeWidth;                             break;
            case 11: pValues[nProp] <<= nLogoSizeTypeHeight;                            break;
            case 12: pValues[nProp] <<= nLogoAlignmentAlignmentTypePosition;            break;
            case 13: pValues[nProp] <<= nLogoAlignmentPositionTypeLeft;                 break;
            case 14: pValues[nProp] <<= nLogoAlignmentPositionTypeRight;                break;
            case 15: pValues[nProp] <<= nLogoAlignmentPositionTypeTop;                  break;
            case 16: pValues[nProp] <<= nLogoAlignmentPositionTypeBottom;               break;
            case 17: pValues[nProp].setValue(&bSenderShow, rType);break;
            case 18: pValues[nProp] <<= sSenderContent;                  break;
            case 19: pValues[nProp].setValue(&bSenderRepeat, rType);break;
            case 20: pValues[nProp] <<= nSenderPositionXYTypeX;                         break;
            case 21: pValues[nProp] <<= nSenderPositionXYTypeY;                         break;
            case 22: pValues[nProp] <<= nSenderSizeTypeWidth;                           break;
            case 23: pValues[nProp] <<= nSenderSizeTypeHeight;                          break;
            case 24: pValues[nProp] <<= nSenderAlignmentTypePosition;                   break;
            case 25: pValues[nProp] <<= nSenderPositionTypeLeft;                        break;
            case 26: pValues[nProp] <<= nSenderPositionTypeRight;                       break;
            case 27: pValues[nProp] <<= nSenderPositionTypeTop;                         break;
            case 28: pValues[nProp] <<= nSenderPositionTypeBottom;                      break;
            case 29: pValues[nProp] <<= sRecipientDatabase;                             break;
            case 30: pValues[nProp] <<= sRecipientContent;               break;
            case 31: pValues[nProp] <<= sRecipientSalutation;                           break;
            case 32: pValues[nProp] <<= sRecipientSalutationField;                      break;
            case 33: pValues[nProp] <<= nRecipientPositionXYTypeX;                      break;
            case 34: pValues[nProp] <<= nRecipientPositionXYTypeY;                      break;
            case 35: pValues[nProp] <<= nRecipientSizeTypeWidth;                        break;
            case 36: pValues[nProp] <<= nRecipientSizeTypeHeight;                       break;
            case 37: pValues[nProp] <<= nRecipientAlignmentAlignmentTypePosition;       break;
            case 38: pValues[nProp] <<= nRecipientAlignmentPositionTypeLeft;            break;
            case 39: pValues[nProp] <<= nRecipientAlignmentPositionTypeRight;           break;
            case 40: pValues[nProp] <<= nRecipientAlignmentPositionTypeTop;             break;
            case 41: pValues[nProp] <<= nRecipientAlignmentPositionTypeBottom;          break;
            case 42: pValues[nProp].setValue(&bElementsElement1TextElementTypeVisible, rType);break;
            case 43: pValues[nProp] <<= sElementsElement1TextElementTypeContent;        break;
            case 44: pValues[nProp].setValue(&bElementsElement2TextElementTypeVisible, rType);break;
            case 45: pValues[nProp] <<= sElementsElement2TextElementTypeContent;        break;
            case 46: pValues[nProp].setValue(&bElementsElement3TextElementTypeVisible, rType);break;
            case 47: pValues[nProp] <<= sElementsElement3TextElementTypeContent;        break;
            case 48: pValues[nProp].setValue(&bElementsElement4TextElementTypeVisible, rType);break;
            case 49: pValues[nProp] <<= sElementsElement4TextElementTypeContent;        break;
            case 50: pValues[nProp].setValue(&bElementsDateIntElementTypeVisible, rType);break;
            case 51: pValues[nProp] <<= nElementsDateIntElementTypeContent;             break;
            case 52: pValues[nProp].setValue(&bElementsSubjectTextElementTypeVisible, rType);break;
            case 53: pValues[nProp] <<= sElementsSubjectTextElementTypeContent;         break;
            case 54: pValues[nProp].setValue(&bElementsCopy, rType);break;
            case 55: pValues[nProp].setValue(&bElementsEnclosure, rType);break;
            case 56: pValues[nProp].setValue(&bElementsPageNumberVisible, rType);break;
            case 57: pValues[nProp] <<= sElementsPageNumberTextBefore;                  break;
            case 58: pValues[nProp] <<= nElementsPageNumberFormat;                      break;
            case 59: pValues[nProp].setValue(&bElementsPageNumberTotalPageCountVisible, rType);break;
            case 60: pValues[nProp] <<= sElementsPageNumberTotalPageCountTextBefore;    break;
            case 61: pValues[nProp] <<= nHeaderFromTop;                                 break;
            case 62: pValues[nProp] <<= nHeaderFromText;                                break;
            case 63: pValues[nProp].setValue(&bHeaderSenderVisible, rType);break;
            case 64: pValues[nProp] <<= nHeaderSenderSizeTypeWidth;                     break;
            case 65: pValues[nProp] <<= nHeaderSenderSizeTypeHeight;                    break;
            case 66: pValues[nProp] <<= nHeaderSenderAlignmentTypePosition;             break;
            case 67: pValues[nProp].setValue(&bHeaderLogoVisible, rType);break;
            case 68: pValues[nProp] <<= nHeaderLogoSizeTypeWidth;                       break;
            case 69: pValues[nProp] <<= nHeaderLogoSizeTypeHeight;                      break;
            case 70: pValues[nProp] <<= nHeaderLogoAlignmentTypePosition;               break;
            case 71: pValues[nProp].setValue(&bFooterOnPage1Enable, rType);break;
            case 72: pValues[nProp].setValue(&bFooterOnPage1Separator, rType);break;
            case 73: pValues[nProp] <<= sFooterOnPage1Text;                             break;
            case 74: pValues[nProp] <<= nFooterOnPage1FromBottom;                       break;
            case 75: pValues[nProp] <<= nFooterOnPage1FromText;                         break;
            case 76: pValues[nProp].setValue(&bFooterOnContinuationPagesEnable, rType);break;
            case 77: pValues[nProp] <<= nFooterOnContinuationPagesFromBottom;           break;
            case 78: pValues[nProp] <<= nFooterOnContinuationPagesFromText;             break;
            case 79: pValues[nProp] <<= sSaveDocInfoTitle;                              break;
            case 80: pValues[nProp] <<= sSaveDocInfoSubject;                            break;
            case 81: pValues[nProp] <<= sSaveTemplateName;                              break;
            case 82: pValues[nProp] <<= sSaveTemplateInfo;                              break;
            case 83: pValues[nProp].setValue(&bSaveAutoDocName, rType);break;
            case 84: pValues[nProp] <<= sSaveAutoPrefix;                                break;
            case 85: pValues[nProp] <<= sSaveAutoPath;                                  break;
            case 86: pValues[nProp] <<= nPrintSender;                                   break;
            case 87: pValues[nProp] <<= nPrintLogo;                                     break;
            case 88: pValues[nProp] <<= sPrintPrinter;                                  break;
            case 89: pValues[nProp] <<= sPrintTrayPage1;                                break;
            case 90: pValues[nProp] <<= sPrintTrayContinuationPage;                     break;
            case 91: pValues[nProp] <<= nPageMarginLeft;                                break;
            case 92: pValues[nProp] <<= nPageMarginRight;                               break;
            case 93: pValues[nProp] <<= sRecipientDataTable;                             break;
        }
	}
	PutProperties(aNames, aValues);
}
/******************************************************************************

******************************************************************************/
Sequence<OUString> SwFaxWizardCfg::GetPropertyNames()
{
	static const char* aPropNames[] =
	{
        "0Style/PreferredStyle",  //             0
        "0Format/Width",//                       1
        "0Format/Height",//                      2
        "0Title",//                              3
        "1Visible",  //                              4
        "1IsGraphic",  //                            5
        "1Text",  //                                 6
        "1GraphicFile/Name",  //                     7
        "1GraphicFile/Filter",  //                   8
        "1GraphicFile/AsLink",  //                 9
        "1Position/X",  //                        10
        "1Position/Y",  //                        11
        "1Size/Width",  //                        12
        "1Size/Height",  //                       13
        "1Alignment/Type/Position",  //           14
        "aLeft",  //                              15
        "aRight",  //                             16
        "aTop",  //                               17
        "aBottom",  //                            18
        "2Content",  //                           19
        "2TelNumber",   //                        20
        "2FaxNumber",   //                        21
        "2Position/X",  //                        22
        "2Position/Y",  //                        23
        "2Size/Width",  //                        24
        "2Size/Height",  //                       25
        "2Alignment/Type/Position",  //           26
        "bLeft",  //                              27
        "bRight",  //                             28
        "bTop",  //                               29
        "bBottom",  //                            30
        "3Database",  //                          31
        "3TelNumber", //                          32
        "3FaxNumber", //                          33
        "3Content",  //                           34
        "3Position/X",  //                        35
        "3Position/Y",  //                        36
        "3Size/Width",  //                        37
        "3Size/Height",  //                       38
        "3Alignment/Type/Position",  //           39
        "cLeft",  //                              40
        "cRight",  //                             41
        "cTop",  //                               42
        "cBottom",  //                            43
        "91/Text/Visible",  //                    44
        "91/Text/Content",  //                    45
        "92/Text/Visible",  //                    46
        "92/Text/Content",  //                    47
        "93/Text/Visible",  //                    48
        "93/Text/Content",  //                    49
        "94/Text/Visible",  //                    50
        "94/Text/Content",  //                    51
        "4Date/Value/Visible",  //                52
        "4Date/Value/Content",  //                53
        "4Time/Value/Visible", //                 54
        "4Time/Value/Content", //                 55
        "4Subject/Value/Visible",  //             56
        "4Subject/Value/Content",  //             57
        "4Copy",  //                              58
        "7Enable",  //                            59
        "7Separator",  //                         60
        "7Text",  //                              61
        "PageMargin/Left",//                      62
        "PageMargin/Right",//                     63
        "5DocInfoTitle",  //                      64
        "5DocInfoSubject",  //                    65
        "5TemplateName",  //                      66
        "5TemplateInfo",  //                      67
        "5AutoDocName",  //                       68
        "5AutoPrefix",  //                        69
        "5AutoPath",  //                          70
        "3DataTable"  //                        71
    };
    const int nCount = sizeof( aPropNames ) / sizeof( const char* );
	Sequence<OUString> aNames(nCount);
	OUString* pNames = aNames.getArray();
	for(int i = 0; i < nCount; i++)
	{
		pNames[i] = OUString::createFromAscii(aPropNames[i]);
        lcl_ExpandPlaceHolder(pNames[i]);
    }
	return aNames;
}
/* -----------------------------25.09.00 09:44--------------------------------

 ---------------------------------------------------------------------------*/
SwFaxWizardCfg::SwFaxWizardCfg() :
    ConfigItem( C2U("Office.Writer/Wizard/Fax")),
    bLogoGraphicAsLink(false)
{
	Sequence<OUString> aNames = GetPropertyNames();
	Sequence<Any> aValues = GetProperties(aNames);
	const Any* pValues = aValues.getConstArray();
	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
	if(aValues.getLength() == aNames.getLength())
	{
		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
		{
			if(pValues[nProp].hasValue())
			{
				SetValuesRead();
				switch(nProp)
				{
					case 0:			pValues[nProp] >>= nTemplateStylePreferredStyle; break;
					case 1:         pValues[nProp] >>= nTemplateFormatWidth; break;
					case 2:         pValues[nProp] >>= nTemplateFormatHeight; break;
					case 3:         pValues[nProp] >>= sTemplateTitle; break;
					case 4:         bLogoVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 5:         bLogoIsGraphic = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 6:         pValues[nProp] >>= sLogoText; break;
					case 7:         pValues[nProp] >>= sLogoGraphicFileName; break;
					case 8:         pValues[nProp] >>= sLogoGraphicFileFilter; break;
                    case 9 :         bLogoGraphicAsLink = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 10:         pValues[nProp] >>= nLogoPositionX; break;
                    case 11:        pValues[nProp] >>= nLogoPositionY; break;
                    case 12:        pValues[nProp] >>= nLogoSizeWidth; break;
                    case 13:        pValues[nProp] >>= nLogoSizeHeight; break;
                    case 14:        pValues[nProp] >>= nLogoAlignmentTypePosition; break;
                    case 15:        pValues[nProp] >>= nLogoAlignmentPositionLeft; break;
                    case 16:        pValues[nProp] >>= nLogoAlignmentPositionRight; break;
                    case 17:        pValues[nProp] >>= nLogoAlignmentPositionTop; break;
                    case 18:        pValues[nProp] >>= nLogoAlignmentPositionBottom; break;
                    case 19:        pValues[nProp] >>= sSenderContent; break;
                    case 20:        pValues[nProp] >>= sSenderTelNumber; break;
                    case 21:        pValues[nProp] >>= sSenderFaxNumber; break;
                    case 22:        pValues[nProp] >>= nSenderPositionX; break;
                    case 23:        pValues[nProp] >>= nSenderPositionY; break;
                    case 24:        pValues[nProp] >>= nSenderSizeWidth; break;
                    case 25:        pValues[nProp] >>= nSenderSizeHeight; break;
                    case 26:        pValues[nProp] >>= nSenderAlignmentTypePosition; break;
                    case 27:        pValues[nProp] >>= nSenderAlignmentPositionLeft; break;
                    case 28:        pValues[nProp] >>= nSenderAlignmentPositionRight; break;
                    case 29:        pValues[nProp] >>= nSenderAlignmentPositionTop; break;
                    case 30:        pValues[nProp] >>= nSenderAlignmentPositionBottom; break;
                    case 31:        pValues[nProp] >>= sRecipientDatabase; break;
                    case 32:        pValues[nProp] >>= sRecipientTelNumber; break;
                    case 33:        pValues[nProp] >>= sRecipientFaxNumber; break;
                    case 34:        pValues[nProp] >>= sRecipientContent; break;
                    case 35:        pValues[nProp] >>= nRecipientPositionX; break;
                    case 36:        pValues[nProp] >>= nRecipientPositionY; break;
                    case 37:        pValues[nProp] >>= nRecipientSizeWidth; break;
                    case 38:        pValues[nProp] >>= nRecipientSizeHeight; break;
                    case 39:        pValues[nProp] >>= nRecipientAlignmentTypePosition; break;
                    case 40:        pValues[nProp] >>= nRecipientAlignmentPositionLeft; break;
                    case 41:        pValues[nProp] >>= nRecipientAlignmentPositionRight; break;
                    case 42:        pValues[nProp] >>= nRecipientAlignmentPositionTop; break;
                    case 43:        pValues[nProp] >>= nRecipientAlignmentPositionBottom; break;
                    case 44:        bElementsElement1TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 45:        pValues[nProp] >>= sElementsElement1TextContent; break;
                    case 46:        bElementsElement2TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 47:        pValues[nProp] >>= sElementsElement2TextContent; break;
                    case 48:        bElementsElement3TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 49:        pValues[nProp] >>= sElementsElement3TextContent; break;
                    case 50:        bElementsElement4TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 51:        pValues[nProp] >>= sElementsElement4TextContent; break;
                    case 52:        bElementsDateValueVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 53:        pValues[nProp] >>= nElementsDateValueContent; break;
                    case 54:        bElementsTimeValueVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 55:        pValues[nProp] >>= nElementsTimeValueContent; break;
                    case 56:        bElementsSubjectValueVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 57:        pValues[nProp] >>= sElementsSubjectValueContent; break;
                    case 58:        bElementsCopy = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 59:        bFooterEnable = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 60:        bFooterSeparator = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 61:        pValues[nProp] >>= sFooterText; break;
                    case 62:        pValues[nProp] >>= nPageMarginLeft; break;
                    case 63:        pValues[nProp] >>= nPageMarginRight; break;
                    case 64:        pValues[nProp] >>= sSaveDocInfoTitle; break;
                    case 65:        pValues[nProp] >>= sSaveDocInfoSubject; break;
                    case 66:        pValues[nProp] >>= sSaveTemplateName; break;
                    case 67:        pValues[nProp] >>= sSaveTemplateInfo; break;
                    case 68:        bSaveAutoDocName = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 69:        pValues[nProp] >>= sSaveAutoPrefix; break;
                    case 70:        pValues[nProp] >>= sSaveAutoPath; break;
                    case 71:        pValues[nProp] >>= sRecipientDataTable; break;
                }
			}
		}
	}
}
/* -----------------------------25.09.00 09:44--------------------------------

 ---------------------------------------------------------------------------*/
SwFaxWizardCfg::~SwFaxWizardCfg()
{
}
/* -----------------------------25.09.00 09:44--------------------------------

 ---------------------------------------------------------------------------*/
void SwFaxWizardCfg::Commit()
{
	Sequence<OUString> aNames = GetPropertyNames();

	OUString* pNames = aNames.getArray();
	Sequence<Any> aValues(aNames.getLength());
	Any* pValues = aValues.getArray();

	const Type& rType = ::getBooleanCppuType();
	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
	{
		switch(nProp)
		{
			case 0:	pValues[nProp] <<= nTemplateStylePreferredStyle; break;
			case 1: pValues[nProp] <<= nTemplateFormatWidth; break;
			case 2: pValues[nProp] <<= nTemplateFormatHeight; break;
			case 3: pValues[nProp] <<= sTemplateTitle; break;
			case 4: pValues[nProp].setValue(&bLogoVisible, rType); break;
			case 5: pValues[nProp].setValue(&bLogoIsGraphic, rType); break;
			case 6: pValues[nProp] <<= sLogoText; break;
			case 7: pValues[nProp] <<= sLogoGraphicFileName; break;
			case 8: pValues[nProp] <<= sLogoGraphicFileFilter; break;
            case 9 : pValues[nProp].setValue(&bLogoGraphicAsLink, rType); break;
            case 10: pValues[nProp] <<= nLogoPositionX; break;
            case 11:pValues[nProp] <<= nLogoPositionY; break;
            case 12:pValues[nProp] <<= nLogoSizeWidth; break;
            case 13:pValues[nProp] <<= nLogoSizeHeight; break;
            case 14:pValues[nProp] <<= nLogoAlignmentTypePosition; break;
            case 15:pValues[nProp] <<= nLogoAlignmentPositionLeft; break;
            case 16:pValues[nProp] <<= nLogoAlignmentPositionRight; break;
            case 17:pValues[nProp] <<= nLogoAlignmentPositionTop; break;
            case 18:pValues[nProp] <<= nLogoAlignmentPositionBottom; break;
            case 19:pValues[nProp] <<= sSenderContent; break;
            case 20:pValues[nProp] <<= sSenderTelNumber; break;
            case 21:pValues[nProp] <<= sSenderFaxNumber; break;
            case 22:pValues[nProp] <<= nSenderPositionX; break;
            case 23:pValues[nProp] <<= nSenderPositionY; break;
            case 24:pValues[nProp] <<= nSenderSizeWidth; break;
            case 25:pValues[nProp] <<= nSenderSizeHeight; break;
            case 26:pValues[nProp] <<= nSenderAlignmentTypePosition; break;
            case 27:pValues[nProp] <<= nSenderAlignmentPositionLeft; break;
            case 28:pValues[nProp] <<= nSenderAlignmentPositionRight; break;
            case 29:pValues[nProp] <<= nSenderAlignmentPositionTop; break;
            case 30:pValues[nProp] <<= nSenderAlignmentPositionBottom; break;
            case 31:pValues[nProp] <<= sRecipientDatabase; break;
            case 32:pValues[nProp] <<= sRecipientTelNumber; break;
            case 33:pValues[nProp] <<= sRecipientFaxNumber; break;
            case 34:pValues[nProp] <<= sRecipientContent; break;
            case 35:pValues[nProp] <<= nRecipientPositionX; break;
            case 36:pValues[nProp] <<= nRecipientPositionY; break;
            case 37:pValues[nProp] <<= nRecipientSizeWidth; break;
            case 38:pValues[nProp] <<= nRecipientSizeHeight; break;
            case 39:pValues[nProp] <<= nRecipientAlignmentTypePosition; break;
            case 40:pValues[nProp] <<= nRecipientAlignmentPositionLeft; break;
            case 41:pValues[nProp] <<= nRecipientAlignmentPositionRight; break;
            case 42:pValues[nProp] <<= nRecipientAlignmentPositionTop; break;
            case 43:pValues[nProp] <<= nRecipientAlignmentPositionBottom; break;
            case 44:pValues[nProp].setValue(&bElementsElement1TextVisible, rType); break;
            case 45:pValues[nProp] <<= sElementsElement1TextContent; break;
            case 46:pValues[nProp].setValue(&bElementsElement2TextVisible, rType); break;
            case 47:pValues[nProp] <<= sElementsElement2TextContent; break;
            case 48:pValues[nProp].setValue(&bElementsElement3TextVisible, rType); break;
            case 49:pValues[nProp] <<= sElementsElement3TextContent; break;
            case 50:pValues[nProp].setValue(&bElementsElement4TextVisible, rType); break;
            case 51:pValues[nProp] <<= sElementsElement4TextContent; break;
            case 52:pValues[nProp].setValue(&bElementsDateValueVisible, rType); break;
            case 53:pValues[nProp] <<= nElementsDateValueContent; break;
            case 54:pValues[nProp].setValue(&bElementsTimeValueVisible, rType); break;
            case 55:pValues[nProp] <<= nElementsTimeValueContent; break;
            case 56:pValues[nProp].setValue(&bElementsSubjectValueVisible, rType); break;
            case 57:pValues[nProp] <<= sElementsSubjectValueContent; break;
            case 58:pValues[nProp].setValue(&bElementsCopy, rType); break;
            case 59:pValues[nProp].setValue(&bFooterEnable, rType); break;
            case 60:pValues[nProp].setValue(&bFooterSeparator, rType); break;
            case 61:pValues[nProp] <<= sFooterText; break;
            case 62:pValues[nProp] <<= nPageMarginLeft; break;
            case 63:pValues[nProp] <<= nPageMarginRight; break;
            case 64:pValues[nProp] <<= sSaveDocInfoTitle; break;
            case 65:pValues[nProp] <<= sSaveDocInfoSubject; break;
            case 66:pValues[nProp] <<= sSaveTemplateName; break;
            case 67:pValues[nProp] <<= sSaveTemplateInfo; break;
            case 68:pValues[nProp].setValue(&bSaveAutoDocName, rType); break;
            case 69:pValues[nProp] <<= sSaveAutoPrefix; break;
            case 70:pValues[nProp] <<= sSaveAutoPath; break;
            case 71:pValues[nProp] <<= sRecipientDataTable; break;
        }
	}
	PutProperties(aNames, aValues);
}
/******************************************************************************

******************************************************************************/
Sequence<OUString> SwMemoWizardCfg::GetPropertyNames()
{
	static const char* aPropNames[] =
	{
        "0Style/PreferredStyle",  //     0
        "0Title/Text",            //     1
        "0Title/IsGraphic",       //     2
        "0Title/File/Name",       //     3
        "0Title/File/Filter",     //     4
        "0Title/File/AsLink",     //     5
        "91/Text/Visible",  //           6
        "91/Text/Content",  //           7
        "92/Text/Visible",  //           8
        "92/Text/Content",  //           9
        "93/Text/Visible",  //          10
        "93/Text/Content",  //          11
        "94/Text/Visible",  //          12
        "94/Text/Content",  //          13
        "4Date/Value/Visible",  //      14
        "4Date/Value/Content",  //      15
        "4Subject/Text/Visible",  //    16
        "4Subject/Text/Content",  //    17
        "4To",                    //    18
        "4Copy",                  //    19
        "4From",                  //    20
        "6Date",                    //  21
        "6Title",                   //  22
        "6PageNumber",              //  23
        "6Separator",               //  24
        "7Date",  //                    25
        "7PageNumber",  //              26
        "7Separator",  //               27
        "7ConfidentialLevel/Visible",// 28
        "7ConfidentialLevel/Content",// 29
        "5DocInfoTitle",  //            30
        "5DocInfoSubject",  //          31
        "5TemplateName",  //            32
        "5TemplateInfo",  //            33
        "5AutoDocName",  //             34
        "5AutoPrefix",   //             35
        "5AutoPath" //                  36
	};
    const int nCount = sizeof( aPropNames ) / sizeof( const char* );
	Sequence<OUString> aNames(nCount);
	OUString* pNames = aNames.getArray();
	for(int i = 0; i < nCount; i++)
	{
		pNames[i] = OUString::createFromAscii(aPropNames[i]);
        lcl_ExpandPlaceHolder(pNames[i]);
    }
	return aNames;
}
/* -----------------------------25.09.00 09:45--------------------------------

 ---------------------------------------------------------------------------*/
SwMemoWizardCfg::SwMemoWizardCfg() :
    ConfigItem( C2U("Office.Writer/Wizard/Memo")),
    bTitleFileAsLink(false)
{
	Sequence<OUString> aNames = GetPropertyNames();
	Sequence<Any> aValues = GetProperties(aNames);
	const Any* pValues = aValues.getConstArray();
	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
	if(aValues.getLength() == aNames.getLength())
	{
		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
		{
			if(pValues[nProp].hasValue())
			{
				SetValuesRead();
				switch(nProp)
				{
					case 0:		pValues[nProp] >>= nTemplateStylePreferredStyle; break;
					case 1:     pValues[nProp] >>= sTemplateTitleText; break;
					case 2:     bTemplateTitleIsGraphic = *(sal_Bool*)pValues[nProp].getValue(); break;
					case 3:     pValues[nProp] >>= sTemplateTitleFileName; break;
					case 4:     pValues[nProp] >>= sTitleFileFilter; break;
                    case 5 :     bTitleFileAsLink = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 6 :     bElementsElement1TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 7 :     pValues[nProp] >>= sElementsElement1TextContent; break;
                    case 8 :     bElementsElement2TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 9 :     pValues[nProp] >>= sElementsElement2TextContent; break;
                    case 10:     bElementsElement3TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 11:    pValues[nProp] >>= sElementsElement3TextContent; break;
                    case 12:    bElementsElement4TextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 13:    pValues[nProp] >>= sElementsElement4TextContent; break;
                    case 14:    bElementsDateValueVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 15:    pValues[nProp] >>= nElementsDateValueContent; break;
                    case 16:    bElementsSubjectTextVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 17:    pValues[nProp] >>= sElementsSubjectTextContent; break;
                    case 18:    bElementsTo = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 19:    bElementsCopy = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 20:    bElementsFrom = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 21:    bHeaderDate = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 22:    bHeaderTitle = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 23:    bHeaderPageNumber = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 24:    bHeaderSeparator = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 25:    bFooterDate = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 26:    bFooterPageNumber = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 27:    bFooterSeparator = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 28:    bFooterConfidentialLevelVisible = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 29:    pValues[nProp] >>= sFooterConfidentialLevelContent; break;
                    case 30:    pValues[nProp] >>= sSaveDocInfoTitle; break;
                    case 31:    pValues[nProp] >>= sSaveDocInfoSubject; break;
                    case 32:    pValues[nProp] >>= sSaveTemplateName; break;
                    case 33:    pValues[nProp] >>= sSaveTemplateInfo; break;
                    case 34:    bSaveAutoDocName = *(sal_Bool*)pValues[nProp].getValue(); break;
                    case 35:    pValues[nProp] >>= sSaveAutoPrefix; break;
                    case 36:    pValues[nProp] >>= sSaveAutoPath; break;
				}
			}
		}
	}
}
/* -----------------------------25.09.00 09:45--------------------------------

 ---------------------------------------------------------------------------*/
SwMemoWizardCfg::~SwMemoWizardCfg()
{
}
/* -----------------------------25.09.00 09:45--------------------------------

 ---------------------------------------------------------------------------*/
void SwMemoWizardCfg::Commit()
{
	Sequence<OUString> aNames = GetPropertyNames();

	OUString* pNames = aNames.getArray();
	Sequence<Any> aValues(aNames.getLength());
	Any* pValues = aValues.getArray();

	const Type& rType = ::getBooleanCppuType();
	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
	{
		switch(nProp)
		{
			case 0:		pValues[nProp] <<= nTemplateStylePreferredStyle; break;
			case 1:     pValues[nProp] <<= sTemplateTitleText; break;
			case 2:     pValues[nProp].setValue(&bTemplateTitleIsGraphic, rType); break;
			case 3:     pValues[nProp] <<= sTemplateTitleFileName; break;
			case 4:     pValues[nProp] <<= sTitleFileFilter; break;
            case 5 :     pValues[nProp].setValue(&bTitleFileAsLink, rType); break;
            case 6 :     pValues[nProp].setValue(&bElementsElement1TextVisible, rType); break;
            case 7 :     pValues[nProp] <<= sElementsElement1TextContent; break;
            case 8 :     pValues[nProp].setValue(&bElementsElement2TextVisible, rType); break;
            case 9 :     pValues[nProp] <<= sElementsElement2TextContent; break;
            case 10:     pValues[nProp].setValue(&bElementsElement3TextVisible, rType); break;
            case 11:    pValues[nProp] <<= sElementsElement3TextContent; break;
            case 12:    pValues[nProp].setValue(&bElementsElement4TextVisible, rType); break;
            case 13:    pValues[nProp] <<= sElementsElement4TextContent; break;
            case 14:    pValues[nProp].setValue(&bElementsDateValueVisible, rType); break;
            case 15:    pValues[nProp] <<= nElementsDateValueContent; break;
            case 16:    pValues[nProp].setValue(&bElementsSubjectTextVisible, rType); break;
            case 17:    pValues[nProp] <<= sElementsSubjectTextContent; break;
            case 18:    pValues[nProp].setValue(&bElementsTo, rType); break;
            case 19:    pValues[nProp].setValue(&bElementsCopy, rType); break;
            case 20:    pValues[nProp].setValue(&bElementsFrom, rType); break;
            case 21:    pValues[nProp].setValue(&bHeaderDate, rType); break;
            case 22:    pValues[nProp].setValue(&bHeaderTitle, rType); break;
            case 23:    pValues[nProp].setValue(&bHeaderPageNumber, rType); break;
            case 24:    pValues[nProp].setValue(&bHeaderSeparator, rType); break;
            case 25:    pValues[nProp].setValue(&bFooterDate, rType); break;
            case 26:    pValues[nProp].setValue(&bFooterPageNumber, rType); break;
            case 27:    pValues[nProp].setValue(&bFooterSeparator, rType); break;
            case 28:    pValues[nProp].setValue(&bFooterConfidentialLevelVisible, rType); break;
            case 29:    pValues[nProp] <<= sFooterConfidentialLevelContent; break;
            case 30:    pValues[nProp] <<= sSaveDocInfoTitle; break;
            case 31:    pValues[nProp] <<= sSaveDocInfoSubject; break;
            case 32:    pValues[nProp] <<= sSaveTemplateName; break;
            case 33:    pValues[nProp] <<= sSaveTemplateInfo; break;
            case 34:    pValues[nProp].setValue(&bSaveAutoDocName, rType); break;
            case 35:    pValues[nProp] <<= sSaveAutoPrefix; break;
            case 36:    pValues[nProp] <<= sSaveAutoPath; break;
		}
	}
	PutProperties(aNames, aValues);
}


}
