/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: numfmtsh.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:58:12 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_NUMFMTSH_HXX
#define _SVX_NUMFMTSH_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _STRING_HXX //autogen
// auto strip #include <tools/string.hxx>
// auto strip #endif
// auto strip #ifndef _LANG_HXX //autogen
// auto strip #include <tools/lang.hxx>
// auto strip #endif

#ifndef	_SVSTDARR_ULONGS
#define _SVSTDARR_ULONGS
#endif
#ifndef	_SVSTDARR_USHORTS
#define _SVSTDARR_USHORTS
#endif
#ifndef	_SVSTDARR_STRINGS
#define _SVSTDARR_STRINGS
#endif

#include <svtools/svstdarr.hxx>
class Color;
class SvNumberFormatter;
class SvStrings;
class SvStringsDtor;
namespace binfilter {

// forward ---------------------------------------------------------------

class SvNumberFormatTable;
class NfCurrencyEntry;
// enum ------------------------------------------------------------------

enum SvxNumberValueType
{
	SVX_VALUE_TYPE_UNDEFINED = 0,
	SVX_VALUE_TYPE_NUMBER,
	SVX_VALUE_TYPE_STRING
};

// define ----------------------------------------------------------------

#define CAT_ALL				0	// Reihenfolge der Kategorie-
#define CAT_USERDEFINED		1	// ListBox-Eintraege in der TabPage
#define CAT_NUMBER			2
#define CAT_PERCENT			3
#define CAT_CURRENCY		4
#define CAT_DATE			5
#define CAT_TIME			6
#define CAT_SCIENTIFIC		7
#define CAT_FRACTION		8
#define CAT_BOOLEAN			9
#define CAT_TEXT			10

#define SELPOS_NONE			-1

#define NUMBERFORMAT_ENTRY_NEW_CURRENCY		NUMBERFORMAT_ENTRY_NOT_FOUND-1

typedef NfCurrencyEntry* NfShCurrencyEntryPtr;
//STRIP001 SV_DECL_PTRARR( NfShCurrencyEntries, NfShCurrencyEntryPtr, 8, 1 )//STRIP008 ;

class SvxDelStrgs: public SvStrings
{

public:
		~SvxDelStrgs() { DeleteAndDestroy(0,Count());}

};

// class SvxNumberFormatShell --------------------------------------------

//STRIP001 class SvxNumberFormatShell
//STRIP001 {
//STRIP001 public:
//STRIP001 						SvxNumberFormatShell( SvNumberFormatter* pNumFormatter,
//STRIP001 											  ULONG              nFormatKey,
//STRIP001 											  SvxNumberValueType eNumValType,
//STRIP001 											  const String&		 rNumStr );
//STRIP001 
//STRIP001 						SvxNumberFormatShell( SvNumberFormatter* pNumFormatter,
//STRIP001 											  ULONG				 nFormatKey,
//STRIP001 											  SvxNumberValueType eNumValType,
//STRIP001 											  double			 nNumVal,
//STRIP001 											  const String*		 pNumStr = NULL );
//STRIP001 
//STRIP001 						~SvxNumberFormatShell();
//STRIP001 
//STRIP001 
//STRIP001 	static SvxNumberFormatShell*	Create( SvNumberFormatter* pNumFormatter,
//STRIP001 											  ULONG              nFormatKey,
//STRIP001 											  SvxNumberValueType eNumValType,
//STRIP001 											  const String&		 rNumStr );

//STRIP001 	static SvxNumberFormatShell*	Create( SvNumberFormatter* pNumFormatter,
//STRIP001 											  ULONG				 nFormatKey,
//STRIP001 											  SvxNumberValueType eNumValType,
//STRIP001 											  double			 nNumVal,
//STRIP001 											  const String*		 pNumStr = NULL );
//STRIP001 
//STRIP001 
//STRIP001 	void				GetInitSettings( USHORT&       nCatLbPos,
//STRIP001 										LanguageType& rLangType,
//STRIP001 										 USHORT&       nFmtLbSelPos,
//STRIP001 										 SvStrings&    rFmtEntries,
//STRIP001 										 String&	   rPrevString,
//STRIP001                                          Color*&       rpPrevColor );
//STRIP001 
//STRIP001 	void				CategoryChanged( USHORT     nCatLbPos,
//STRIP001 										short&     rFmtSelPos,
//STRIP001 										 SvStrings& rFmtEntries );
//STRIP001 
//STRIP001 	void				LanguageChanged( LanguageType eLangType,
//STRIP001 										 short&       rFmtSelPos,
//STRIP001 										 SvStrings&   rFmtEntries );
//STRIP001 
//STRIP001 	void				FormatChanged( USHORT  nFmtLbPos,
//STRIP001 									   String& rPreviewStr,
//STRIP001                                        Color*& rpFontColor );
//STRIP001 
//STRIP001 	BOOL				AddFormat( String&    rFormat,
//STRIP001 								   ULONG&     rErrPos,
//STRIP001 								   USHORT&    rCatLbSelPos,
//STRIP001 								   short&     rFmtSelPos,
//STRIP001 								   SvStrings& rFmtEntries );
//STRIP001 
//STRIP001 	BOOL				RemoveFormat( const String&	rFormat,
//STRIP001 									  USHORT&       rCatLbSelPos,
//STRIP001 									  short&        rFmtSelPos,
//STRIP001 									  SvStrings&    rFmtEntries );
//STRIP001 
//STRIP001 	void				MakeFormat( String& rFormat,
//STRIP001 									BOOL    bThousand,
//STRIP001 									BOOL    bNegRed,
//STRIP001 									USHORT  nPrecision,
//STRIP001 									USHORT  nLeadingZeroes,
//STRIP001 									USHORT  nCurrencyEntryPos);
//STRIP001 
//STRIP001 	void				GetOptions( const String& rFormat,
//STRIP001 									BOOL&         rThousand,
//STRIP001 									BOOL&         rNegRed,
//STRIP001 									USHORT&       rPrecision,
//STRIP001 									USHORT&       rLeadingZeroes,
//STRIP001 									USHORT&       rCatLbPos );
//STRIP001 
//STRIP001 	void				MakePreviewString( const String& rFormatStr,
//STRIP001 										   String&       rPreviewStr,
//STRIP001                                            Color*&       rpFontColor );
//STRIP001 
//STRIP001 	void				MakePrevStringFromVal( const String& rFormatStr,		//@ 19.09.97
//STRIP001 												String&	rPreviewStr,
//STRIP001                                                 Color*& rpFontColor,
//STRIP001 												double	nValue);
//STRIP001 
//STRIP001 	BOOL				IsUserDefined( const String& rFmtString );
//STRIP001 	BOOL				IsTmpCurrencyFormat( const String& rFmtString );
//STRIP001 	BOOL				FindEntry( const String& rFmtString, ULONG* pAt = NULL );
//STRIP001 
//STRIP001 	void				ValidateNewEntries( BOOL bValidate = TRUE ) { bUndoAddList = !bValidate; }
//STRIP001 	ULONG				GetUpdateDataCount() const;
//STRIP001 	void				GetUpdateData( ULONG* pDelArray, const ULONG nSize );
//STRIP001 
//STRIP001 	void				SetCurNumFmtKey( ULONG nNew )		{ nCurFormatKey = nNew; }
//STRIP001 	void				SetCurLanguage( LanguageType eNew ) { eCurLanguage = eNew; }
//STRIP001 	ULONG				GetCurNumFmtKey() const				{ return nCurFormatKey; }
//STRIP001 	LanguageType		GetCurLanguage() const				{ return eCurLanguage; }
//STRIP001 
//STRIP001 	String				GetComment4Entry(short nEntry);
//STRIP001 	short				GetCategory4Entry(short nEntry);
//STRIP001 	BOOL				GetUserDefined4Entry(short nEntry);
//STRIP001 	String				GetFormat4Entry(short nEntry);
//STRIP001 	void				SetComment4Entry(short nEntry,String aCommentString);
//STRIP001 
//STRIP001 	BOOL				IsBankingSymbol(USHORT nPos);
//STRIP001 	void				SetCurrencySymbol(USHORT nPos);
//STRIP001 	ULONG				GetCurrencySymbol();
//STRIP001 	USHORT				FindCurrencyFormat( const String& rFmtString );
//STRIP001 	USHORT				FindCurrencyFormat(const NfCurrencyEntry* pTmpCurrencyEntry,BOOL bTmpBanking);
//STRIP001 	NfCurrencyEntry*	GetCurCurrencyEntry();
//STRIP001 	void				SetCurCurrencyEntry(NfCurrencyEntry*);
//STRIP001 	short				GetListPos4Entry(ULONG nIdx);
//STRIP001 	short				GetListPos4Entry( const String& rFmtString );
//STRIP001 
//STRIP001 	void				GetCurrencySymbols(SvStringsDtor& rList,const XubString& rStrEurope,USHORT* pPos);
//STRIP001 	void				GetCurrencySymbols(SvStringsDtor& rList,const XubString& rStrEurope, BOOL bFlag);
//STRIP001 
//STRIP001 	USHORT				FindCurrencyTableEntry( const String& rFmtString, BOOL &bTestBanking );
//STRIP001 	BOOL				IsInTable(USHORT nPos,BOOL bTmpBanking,const String &rFmtString);
//STRIP001 
//STRIP001 	void				GetCurrencyFormats(SvStrings& rList);
//STRIP001 
//STRIP001 private:
//STRIP001 	static const double 	DEFAULT_NUMVALUE;	// 123456789
//STRIP001 
//STRIP001 	SvNumberFormatter*		pFormatter;
//STRIP001 	SvNumberFormatTable*	pCurFmtTable;
//STRIP001 	SvxNumberValueType		eValType;
//STRIP001 	String					aValStr;
//STRIP001 	double					nValNum;
//STRIP001 	BOOL					bUndoAddList;
//STRIP001 	SvULongs				aAddList;
//STRIP001 	SvULongs				aDelList;
//STRIP001 	SvULongs				aCurEntryList;
//STRIP001 	ULONG					nInitFormatKey;
//STRIP001 	ULONG					nCurFormatKey;
//STRIP001 	short					nCurCategory;
//STRIP001 	LanguageType			eCurLanguage;
//STRIP001 	SvUShorts				aCurCurrencyList;
//STRIP001 	NfCurrencyEntry*		pCurCurrencyEntry;
//STRIP001 	BOOL					bBankingSymbol;
//STRIP001 	USHORT					nCurCurrencyEntryPos;
//STRIP001 	SvStrings				aCurrencyFormatList;
//STRIP001 
//STRIP001 #ifdef _SVX_NUMFMTSH_CXX
//STRIP001 	short					FillEntryList_Impl( SvStrings& rList );
//STRIP001 	void					FillEListWithStd_Impl( SvStrings& rList,USHORT aPrivCat, short &Pos);
//STRIP001 	short					FillEListWithFormats_Impl( SvStrings& rList,short nSelPos,
//STRIP001 													   NfIndexTableOffset eOffsetStart,
//STRIP001 													   NfIndexTableOffset eOffsetEnd);
//STRIP001 
//STRIP001 	short					FillEListWithDateTime_Impl( SvStrings& rList,short nSelPos);
//STRIP001 
//STRIP001 	short					FillEListWithCurrency_Impl( SvStrings& rList,short nSelPos);
//STRIP001 	short					FillEListWithSysCurrencys( SvStrings& rList,short nSelPos);
//STRIP001 	short					FillEListWithUserCurrencys( SvStrings& rList,short nSelPos);
//STRIP001 
//STRIP001 	short					FillEListWithUsD_Impl( SvStrings& rList, sal_uInt16 nPrivCat, short Pos );
//STRIP001 	BOOL					IsRemoved_Impl( ULONG nKey );
//STRIP001 	BOOL					IsAdded_Impl( ULONG nKey );
//STRIP001 	void					GetPreviewString_Impl( String& rString,
//STRIP001                                                    Color*& rpColor );
//STRIP001 	void					PosToCategory_Impl( USHORT nPos, short& rCategory );
//STRIP001 	void					CategoryToPos_Impl( short nCategory, USHORT& rPos );
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif

