/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tabarea.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 15:07:14 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_TAB_AREA_HXX
#define _SVX_TAB_AREA_HXX

// include ---------------------------------------------------------------

#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
#ifndef _IMAGEBTN_HXX //autogen
#include <vcl/imagebtn.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#include <bf_svx/xoutx.hxx>
#include <bf_svx/dlgctrl.hxx>

#ifndef _SVX_XSETITEM_HXX //autogen
#include <bf_svx/xsetit.hxx>
#endif

#ifndef SVX_XFILLIT0_HXX //autogen
#include <bf_svx/xfillit0.hxx>
#endif

#ifndef _SVX_FILLITEM_HXX //autogen
#include <bf_svx/xfillit.hxx>
#endif
namespace binfilter {

// enum ------------------------------------------------------------------

//STRIP001 enum ColorModel
//STRIP001 {
//STRIP001 	CM_RGB,
//STRIP001 	CM_CMYK // kann um weitere Modelle, z.B. HSV erweitert werden
//STRIP001 };

//STRIP001 enum PageType
//STRIP001 {
//STRIP001 	PT_AREA,
//STRIP001 	PT_GRADIENT,
//STRIP001 	PT_HATCH,
//STRIP001 	PT_BITMAP,
//STRIP001 	PT_COLOR,
//STRIP001 	PT_SHADOW,
//STRIP001 	PT_TRANSPARENCE
//STRIP001 };

// define ----------------------------------------------------------------

//STRIP001 typedef USHORT ChangeType; // auch in tab_line.hxx (mitpflegen !!!)

//STRIP001 #define CT_NONE                 ( (ChangeType) 0x0000 )
//STRIP001 #define CT_MODIFIED             ( (ChangeType) 0x0001 )
//STRIP001 #define CT_CHANGED              ( (ChangeType) 0x0002 )
//STRIP001 #define CT_SAVED                ( (ChangeType) 0x0004 )

//STRIP001 class SdrModel;
//STRIP001 class SdrView;

/*************************************************************************
|*
|* Fl"achen-Tab-Dialog
|*
\************************************************************************/

//STRIP001 class SvxAreaTabDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	SdrModel*           pDrawModel;
//STRIP001 	const SdrView*		pView;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 	XColorTable*        pNewColorTab;
//STRIP001 	XGradientList*      pGradientList;
//STRIP001 	XGradientList*      pNewGradientList;
//STRIP001 	XHatchList*         pHatchingList;
//STRIP001 	XHatchList*         pNewHatchingList;
//STRIP001 	XBitmapList*        pBitmapList;
//STRIP001 	XBitmapList*        pNewBitmapList;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 
//STRIP001 	ChangeType          nColorTableState;
//STRIP001 	ChangeType          nBitmapListState;
//STRIP001 	ChangeType          nGradientListState;
//STRIP001 	ChangeType          nHatchingListState;
//STRIP001 
//STRIP001 	USHORT              nPageType;
//STRIP001 	USHORT              nDlgType;
//STRIP001 	USHORT              nPos;
//STRIP001 	BOOL                bAreaTP;
//STRIP001 	BOOL                bDeleteColorTable;
//STRIP001 
//STRIP001 	virtual void        PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual short       Ok();
//STRIP001 #ifdef _SVX_TABAREA_CXX
//STRIP001 	DECL_LINK( CancelHdl, void * );
//STRIP001 	void                SavePalettes();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxAreaTabDialog( Window* pParent,
//STRIP001 					  const SfxItemSet* pAttr, SdrModel* pModel,
//STRIP001 					  const SdrView* pSdrView = NULL );
//STRIP001 	~SvxAreaTabDialog();
//STRIP001 
//STRIP001 	void            	 SetNewColorTable( XColorTable* pColTab )
//STRIP001 							{ pNewColorTab = pColTab; }
//STRIP001 	XColorTable*    	 GetNewColorTable() const { return pNewColorTab; }
//STRIP001 	const XColorTable*	 GetColorTable() const { return pColorTab; }
//STRIP001 
//STRIP001 	void            	 SetNewGradientList( XGradientList* pGrdLst)
//STRIP001 							{ pNewGradientList = pGrdLst; }
//STRIP001 	XGradientList*  	 GetNewGradientList() const
//STRIP001 							{ return pNewGradientList; }
//STRIP001 	const XGradientList* GetGradientList() const { return pGradientList; }
//STRIP001 
//STRIP001 	void				 SetNewHatchingList( XHatchList* pHtchLst)
//STRIP001 							{ pNewHatchingList = pHtchLst; }
//STRIP001 	XHatchList*     	 GetNewHatchingList() const
//STRIP001 							{ return pNewHatchingList; }
//STRIP001 	const XHatchList*	 GetHatchingList() const { return pHatchingList; }
//STRIP001 
//STRIP001 	void				 SetNewBitmapList( XBitmapList* pBmpLst)
//STRIP001 							{ pNewBitmapList = pBmpLst; }
//STRIP001 	XBitmapList*		 GetNewBitmapList() const { return pNewBitmapList; }
//STRIP001 	const XBitmapList*	 GetBitmapList() const { return pBitmapList; }
//STRIP001 
//STRIP001 	void				 DontDeleteColorTable() { bDeleteColorTable = FALSE; }
//STRIP001 };

/*************************************************************************
|*
|* Transparence-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxTransparenceTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 	RECT_POINT          eRP;
//STRIP001 
//STRIP001 	UINT16*             pPageType;
//STRIP001 	UINT16*             pDlgType;
//STRIP001 
//STRIP001 	// main selection
//STRIP001     FixedLine           aFlProp;
//STRIP001     RadioButton         aRbtTransOff;
//STRIP001     RadioButton         aRbtTransLinear;
//STRIP001 	RadioButton         aRbtTransGradient;
//STRIP001 
//STRIP001 	// linear transparency
//STRIP001 	MetricField         aMtrTransparent;
//STRIP001 
//STRIP001 	// gradient transparency
//STRIP001 	FixedText           aFtTrgrType;
//STRIP001 	ListBox             aLbTrgrGradientType;
//STRIP001 	FixedText           aFtTrgrCenterX;
//STRIP001 	MetricField         aMtrTrgrCenterX;
//STRIP001 	FixedText           aFtTrgrCenterY;
//STRIP001 	MetricField         aMtrTrgrCenterY;
//STRIP001 	FixedText           aFtTrgrAngle;
//STRIP001 	MetricField         aMtrTrgrAngle;
//STRIP001 	FixedText           aFtTrgrBorder;
//STRIP001 	MetricField         aMtrTrgrBorder;
//STRIP001 	FixedText           aFtTrgrStartValue;
//STRIP001 	MetricField         aMtrTrgrStartValue;
//STRIP001 	FixedText           aFtTrgrEndValue;
//STRIP001 	MetricField         aMtrTrgrEndValue;
//STRIP001 
//STRIP001 	// preview
//STRIP001 	SvxXRectPreview     aCtlBitmapPreview;
//STRIP001 	SvxXRectPreview     aCtlXRectPreview;
//STRIP001 	XOutputDevice       XOutBmp;
//STRIP001 	XOutputDevice       XOut;
//STRIP001 	BOOL				bBitmap;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 
//STRIP001 #ifdef _SVX_TPAREA_CXX
//STRIP001 	DECL_LINK(ClickTransOffHdl_Impl, void * );
//STRIP001 	DECL_LINK(ClickTransLinearHdl_Impl, void * );
//STRIP001 	DECL_LINK(ClickTransGradientHdl_Impl, void * );
//STRIP001 	DECL_LINK(ModifyTransparentHdl_Impl, void*);
//STRIP001 	DECL_LINK(ChangeTrgrTypeHdl_Impl, void*);
//STRIP001 	DECL_LINK(ModifiedTrgrHdl_Impl, void*);
//STRIP001 #endif
//STRIP001 
//STRIP001 	void ActivateLinear(BOOL bActivate);
//STRIP001 	void ActivateGradient(BOOL bActivate);
//STRIP001 	void SetControlState_Impl(XGradientStyle eXGS);
//STRIP001 
//STRIP001 	BOOL InitPreview ( const SfxItemSet& rSet );
//STRIP001 	void InvalidatePreview (BOOL bEnable = TRUE );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxTransparenceTabPage(Window* pParent, const SfxItemSet& rInAttrs);
//STRIP001 	void Construct();
//STRIP001 
//STRIP001 	static SfxTabPage* Create(Window*, const SfxItemSet&);
//STRIP001 	static UINT16* GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL FillItemSet(SfxItemSet&);
//STRIP001 	virtual void Reset(const SfxItemSet&);
//STRIP001 	virtual void ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int  DeactivatePage(SfxItemSet* pSet);
//STRIP001 	virtual void PointChanged(Window* pWindow, RECT_POINT eRP);
//STRIP001 
//STRIP001 	void SetPageType(UINT16 *pInType) { pPageType = pInType; }
//STRIP001 	void SetDlgType(UINT16* pInType) { pDlgType = pInType; }
//STRIP001 };

/*************************************************************************
|*
|* Fl"achen-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxAreaTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001     FixedLine           aFlProp;
//STRIP001     RadioButton         aRbtNoFill;
//STRIP001     RadioButton         aRbtColor;
//STRIP001     RadioButton         aRbtGradient;
//STRIP001     RadioButton         aRbtHatch;
//STRIP001     RadioButton         aRbtBitmap;
//STRIP001 
//STRIP001 //      ListBox             aDlgType;
//STRIP001 	ColorLB             aLbColor;
//STRIP001 	GradientLB          aLbGradient;
//STRIP001 	HatchingLB          aLbHatching;
//STRIP001 	BitmapLB            aLbBitmap;
//STRIP001 	SvxXRectPreview     aCtlBitmapPreview;
//STRIP001 
//STRIP001 	TriStateBox         aTsbStepCount;
//STRIP001     FixedLine           aFlStepCount;
//STRIP001 	NumericField        aNumFldStepCount;
//STRIP001 
//STRIP001 	CheckBox			aCbxHatchBckgrd;
//STRIP001 	ColorLB             aLbHatchBckgrdColor;
//STRIP001 
//STRIP001     FixedLine           aFlSize;
//STRIP001 	TriStateBox			aTsbOriginal;
//STRIP001 	TriStateBox			aTsbScale;
//STRIP001 	FixedText			aFtXSize;
//STRIP001 	MetricField			aMtrFldXSize;
//STRIP001 	FixedText			aFtYSize;
//STRIP001 	MetricField			aMtrFldYSize;
//STRIP001     FixedLine           aFlPosition;
//STRIP001 	SvxRectCtl			aCtlPosition;
//STRIP001 	FixedText			aFtXOffset;
//STRIP001 	MetricField			aMtrFldXOffset;
//STRIP001 	FixedText			aFtYOffset;
//STRIP001 	MetricField			aMtrFldYOffset;
//STRIP001 	TriStateBox         aTsbTile;
//STRIP001 	TriStateBox         aTsbStretch;
//STRIP001     FixedLine           aFlOffset;
//STRIP001 	RadioButton			aRbtRow;
//STRIP001 	RadioButton			aRbtColumn;
//STRIP001 	MetricField			aMtrFldOffset;
//STRIP001 
//STRIP001 	SvxXRectPreview     aCtlXRectPreview;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 	RECT_POINT          eRP;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 	XGradientList*      pGradientList;
//STRIP001 	XHatchList*         pHatchingList;
//STRIP001 	XBitmapList*        pBitmapList;
//STRIP001 
//STRIP001 	ChangeType*         pnColorTableState;
//STRIP001 	ChangeType*         pnBitmapListState;
//STRIP001 	ChangeType*         pnGradientListState;
//STRIP001 	ChangeType*         pnHatchingListState;
//STRIP001 
//STRIP001 	USHORT*             pPageType;
//STRIP001 	USHORT*             pDlgType;
//STRIP001 	USHORT*             pPos;
//STRIP001 	BOOL*               pbAreaTP;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XOutputDevice       XOut;
//STRIP001 	XOutputDevice       XOutBmp;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 
//STRIP001 	SfxMapUnit			ePoolUnit;
//STRIP001 	FieldUnit			eFUnit;
//STRIP001 
//STRIP001 #ifdef _SVX_TPAREA_CXX
//STRIP001 	DECL_LINK( SelectDialogType_Impl, void * );
//STRIP001 	DECL_LINK( ClickInvisibleHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickColorHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyColorHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyHatchBckgrdColorHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickGradientHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyGradientHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickHatchingHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyHatchingHdl_Impl, void * );
//STRIP001 	DECL_LINK( ToggleHatchBckgrdColorHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickBitmapHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyBitmapHdl_Impl, void * );
//STRIP001 //	DECL_LINK( ModifyTransparentHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyStepCountHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyTileHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickScaleHdl_Impl, void * );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxAreaTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	void    Construct();
//STRIP001 
//STRIP001 	static  SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	static  USHORT*	    GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void    SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
//STRIP001 	void    SetGradientList( XGradientList* pGrdLst)
//STRIP001 				{ pGradientList = pGrdLst; }
//STRIP001 	void    SetHatchingList( XHatchList* pHtchLst)
//STRIP001 				{ pHatchingList = pHtchLst; }
//STRIP001 	void    SetBitmapList( XBitmapList* pBmpLst) { pBitmapList = pBmpLst; }
//STRIP001 
//STRIP001 	void    SetPageType( USHORT* pInType ) { pPageType = pInType; }
//STRIP001 	void    SetDlgType( USHORT* pInType ) { pDlgType = pInType; }
//STRIP001 	void    SetPos( USHORT* pInPos ) { pPos = pInPos; }
//STRIP001 	void    SetAreaTP( BOOL* pIn ) { pbAreaTP = pIn; }
//STRIP001 
//STRIP001 	void    SetColorChgd( ChangeType* pIn ) { pnColorTableState = pIn; }
//STRIP001 	void    SetGrdChgd( ChangeType* pIn ) { pnGradientListState = pIn; }
//STRIP001 	void    SetHtchChgd( ChangeType* pIn ) { pnHatchingListState = pIn; }
//STRIP001 	void    SetBmpChgd( ChangeType* pIn ) { pnBitmapListState = pIn; }
//STRIP001 };

/*************************************************************************
|*
|* Schatten-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxShadowTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001     FixedLine           aFlProp;
//STRIP001     TriStateBox         aTsbShowShadow;
//STRIP001 	FixedText           aFtPosition;
//STRIP001 	SvxRectCtl          aCtlPosition;
//STRIP001 	FixedText           aFtDistance;
//STRIP001 	MetricField         aMtrDistance;
//STRIP001 	FixedText           aFtShadowColor;
//STRIP001 	ColorLB             aLbShadowColor;
//STRIP001 	FixedText           aFtTransparent;
//STRIP001 	MetricField         aMtrTransparent;
//STRIP001 	SvxXShadowPreview	aCtlXRectPreview;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 	RECT_POINT          eRP;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 	ChangeType*         pnColorTableState;
//STRIP001 	USHORT*             pPageType;
//STRIP001 	USHORT*             pDlgType;
//STRIP001 	USHORT*             pPos;
//STRIP001 	BOOL*               pbAreaTP;
//STRIP001 
//STRIP001 	BOOL				bDisable;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XOutputDevice       XOut;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 	SfxMapUnit			ePoolUnit;
//STRIP001 
//STRIP001 #ifdef _SVX_TPSHADOW_CXX
//STRIP001 	DECL_LINK( ClickShadowHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifyShadowHdl_Impl, void * );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxShadowTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	void    Construct();
//STRIP001 	static  SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	static  USHORT*	    GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void    SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
//STRIP001 	void    SetPageType( USHORT* pInType ) { pPageType = pInType; }
//STRIP001 	void    SetDlgType( USHORT* pInType ) { pDlgType = pInType; }
//STRIP001 	void    SetAreaTP( BOOL* pIn ) { pbAreaTP = pIn; }
//STRIP001 	void    SetColorChgd( ChangeType* pIn ) { pnColorTableState = pIn; }
//STRIP001 
//STRIP001 	void	DisablePage( BOOL bIn ) { bDisable = bIn; }
//STRIP001 };

/*************************************************************************
|*
|* Farbverlauf-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxGradientTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001     FixedLine           aFlProp;
//STRIP001 	FixedText           aFtType;
//STRIP001 	ListBox             aLbGradientType;
//STRIP001 	FixedText           aFtCenterX;
//STRIP001 	MetricField         aMtrCenterX;
//STRIP001 	FixedText           aFtCenterY;
//STRIP001 	MetricField         aMtrCenterY;
//STRIP001 	FixedText           aFtAngle;
//STRIP001 	MetricField         aMtrAngle;
//STRIP001 	FixedText           aFtBorder;
//STRIP001 	MetricField         aMtrBorder;
//STRIP001 	FixedText           aFtColorFrom;
//STRIP001 	ColorLB             aLbColorFrom;
//STRIP001 	MetricField         aMtrColorFrom;
//STRIP001 	FixedText           aFtColorTo;
//STRIP001 	ColorLB             aLbColorTo;
//STRIP001 	MetricField         aMtrColorTo;
//STRIP001 	GradientLB          aLbGradients;
//STRIP001 	SvxXRectPreview     aCtlPreview;
//STRIP001 	PushButton          aBtnAdd;
//STRIP001 	PushButton          aBtnModify;
//STRIP001 	PushButton          aBtnDelete;
//STRIP001 	ImageButton         aBtnLoad;
//STRIP001 	ImageButton         aBtnSave;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 	XGradientList*      pGradientList;
//STRIP001 
//STRIP001 	ChangeType*         pnGradientListState;
//STRIP001 	ChangeType*         pnColorTableState;
//STRIP001 	USHORT*             pPageType;
//STRIP001 	USHORT*             pDlgType;
//STRIP001 	USHORT*             pPos;
//STRIP001 	BOOL*               pbAreaTP;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XOutputDevice       XOut;
//STRIP001 	XFillStyleItem      aXFStyleItem;
//STRIP001 	XFillGradientItem   aXGradientItem;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 
//STRIP001 #ifdef _SVX_TPGRADNT_CXX
//STRIP001 	DECL_LINK( ClickAddHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickModifyHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickDeleteHdl_Impl, void * );
//STRIP001 	DECL_LINK( ChangeGradientHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifiedHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickLoadHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickSaveHdl_Impl, void * );
//STRIP001 
//STRIP001 	long CheckChanges_Impl();
//STRIP001 	void SetControlState_Impl( XGradientStyle eXGS );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxGradientTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	void    Construct();
//STRIP001 
//STRIP001 	static  SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	void    SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
//STRIP001 	void    SetGradientList( XGradientList* pGrdLst)
//STRIP001 				{ pGradientList = pGrdLst; }
//STRIP001 
//STRIP001 	void    SetPageType( USHORT* pInType ) { pPageType = pInType; }
//STRIP001 	void    SetDlgType( USHORT* pInType ) { pDlgType = pInType; }
//STRIP001 	void    SetPos( USHORT* pInPos ) { pPos = pInPos; }
//STRIP001 	void    SetAreaTP( BOOL* pIn ) { pbAreaTP = pIn; }
//STRIP001 
//STRIP001 	void    SetGrdChgd( ChangeType* pIn ) { pnGradientListState = pIn; }
//STRIP001 	void    SetColorChgd( ChangeType* pIn ) { pnColorTableState = pIn; }
//STRIP001 };

/*************************************************************************
|*
|* Schraffuren-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxHatchTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedText           aFtDistance;
//STRIP001 	MetricField         aMtrDistance;
//STRIP001 	FixedText           aFtAngle;
//STRIP001 	MetricField         aMtrAngle;
//STRIP001 	SvxRectCtl          aCtlAngle;
//STRIP001     FixedLine           aFlProp;
//STRIP001 	FixedText           aFtLineType;
//STRIP001 	ListBox             aLbLineType;
//STRIP001 	FixedText           aFtLineColor;
//STRIP001 	ColorLB             aLbLineColor;
//STRIP001 	HatchingLB          aLbHatchings;
//STRIP001 	SvxXRectPreview     aCtlPreview;
//STRIP001 	PushButton          aBtnAdd;
//STRIP001 	PushButton          aBtnModify;
//STRIP001 	PushButton          aBtnDelete;
//STRIP001 	ImageButton         aBtnLoad;
//STRIP001 	ImageButton         aBtnSave;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 	RECT_POINT          eRP;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 	XHatchList*         pHatchingList;
//STRIP001 
//STRIP001 	ChangeType*         pnHatchingListState;
//STRIP001 	ChangeType*         pnColorTableState;
//STRIP001 	USHORT*             pPageType;
//STRIP001 	USHORT*             pDlgType;
//STRIP001 	USHORT*             pPos;
//STRIP001 	BOOL*               pbAreaTP;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XOutputDevice       XOut;
//STRIP001 	XFillStyleItem      aXFStyleItem;
//STRIP001 	XFillHatchItem      aXHatchItem;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 
//STRIP001 	SfxMapUnit			ePoolUnit;
//STRIP001 
//STRIP001 #ifdef _SVX_TPHATCH_CXX
//STRIP001 	DECL_LINK( ChangeHatchHdl_Impl, void * );
//STRIP001 	DECL_LINK( ModifiedHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickAddHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickModifyHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickDeleteHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickLoadHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickSaveHdl_Impl, void * );
//STRIP001 
//STRIP001 	long CheckChanges_Impl();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxHatchTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	void    Construct();
//STRIP001 
//STRIP001 	static  SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void    SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
//STRIP001 	void    SetHatchingList( XHatchList* pHtchLst)
//STRIP001 				{ pHatchingList = pHtchLst; }
//STRIP001 
//STRIP001 	void    SetPageType( USHORT* pInType ) { pPageType = pInType; }
//STRIP001 	void    SetDlgType( USHORT* pInType ) { pDlgType = pInType; }
//STRIP001 	void    SetPos( USHORT* pInPos ) { pPos = pInPos; }
//STRIP001 	void    SetAreaTP( BOOL* pIn ) { pbAreaTP = pIn; }
//STRIP001 
//STRIP001 	void    SetHtchChgd( ChangeType* pIn ) { pnHatchingListState = pIn; }
//STRIP001 	void    SetColorChgd( ChangeType* pIn ) { pnColorTableState = pIn; }
//STRIP001 
//STRIP001 	virtual void		DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 };

/*************************************************************************
|*
|* Bitmap-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxBitmapTabPage : public SvxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvxPixelCtl         aCtlPixel;
//STRIP001     FixedText           aFtPixelEdit;
//STRIP001 	FixedText           aFtColor;
//STRIP001 	ColorLB             aLbColor;
//STRIP001 	FixedText           aFtBackgroundColor;
//STRIP001 	ColorLB             aLbBackgroundColor;
//STRIP001 	FixedText           aLbBitmapsHidden;
//STRIP001 	BitmapLB            aLbBitmaps;
//STRIP001     FixedLine           aFlProp;
//STRIP001 	SvxXRectPreview     aCtlPreview;
//STRIP001 	PushButton          aBtnAdd;
//STRIP001 	PushButton          aBtnModify;
//STRIP001 	PushButton          aBtnImport;
//STRIP001 	PushButton          aBtnDelete;
//STRIP001 	ImageButton         aBtnLoad;
//STRIP001 	ImageButton         aBtnSave;
//STRIP001 
//STRIP001 	SvxBitmapCtl        aBitmapCtl;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 	XBitmapList*        pBitmapList;
//STRIP001 
//STRIP001 	ChangeType*         pnBitmapListState;
//STRIP001 	ChangeType*         pnColorTableState;
//STRIP001 	USHORT*             pPageType;
//STRIP001 	USHORT*             pDlgType;
//STRIP001 	USHORT*             pPos;
//STRIP001 	BOOL*               pbAreaTP;
//STRIP001 
//STRIP001 	BOOL                bBmpChanged;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XOutputDevice       XOut;
//STRIP001 	XFillStyleItem      aXFStyleItem;
//STRIP001 	XFillBitmapItem     aXBitmapItem;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 
//STRIP001 #ifdef _SVX_TPBITMAP_CXX
//STRIP001 	DECL_LINK( ClickAddHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickImportHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickModifyHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickDeleteHdl_Impl, void * );
//STRIP001 	DECL_LINK( ChangeBitmapHdl_Impl, void * );
//STRIP001 	DECL_LINK( ChangePixelColorHdl_Impl, void * );
//STRIP001 	DECL_LINK( ChangeBackgrndColorHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickLoadHdl_Impl, void * );
//STRIP001 	DECL_LINK( ClickSaveHdl_Impl, void * );
//STRIP001 
//STRIP001 	long CheckChanges_Impl();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxBitmapTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	void    Construct();
//STRIP001 
//STRIP001 	static  SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	virtual void PointChanged( Window* pWindow, RECT_POINT eRP );
//STRIP001 
//STRIP001 	void    SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
//STRIP001 	void    SetBitmapList( XBitmapList* pBmpLst) { pBitmapList = pBmpLst; }
//STRIP001 
//STRIP001 	void    SetPageType( USHORT* pInType ) { pPageType = pInType; }
//STRIP001 	void    SetDlgType( USHORT* pInType ) { pDlgType = pInType; }
//STRIP001 	void    SetPos( USHORT* pInPos ) { pPos = pInPos; }
//STRIP001 	void    SetAreaTP( BOOL* pIn ) { pbAreaTP = pIn; }
//STRIP001 
//STRIP001 	void    SetBmpChgd( ChangeType* pIn ) { pnBitmapListState = pIn; }
//STRIP001 	void    SetColorChgd( ChangeType* pIn ) { pnColorTableState = pIn; }
//STRIP001 
//STRIP001     /** Return a label that is associated with the given control.  This
//STRIP001         label is used to the determine the name for the control.
//STRIP001         @param pLabeled
//STRIP001             The control for which to return a label.
//STRIP001         @return
//STRIP001             Return a label control that provides a name for the specified
//STRIP001             control.
//STRIP001     */
//STRIP001     virtual Window*	GetParentLabeledBy( const Window* pLabeled ) const;
//STRIP001 };

/*************************************************************************
|*
|* Farben-Tab-Page
|*
\************************************************************************/

//STRIP001 class SvxColorTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001     FixedLine           aFlProp;
//STRIP001 	FixedText           aFtName;
//STRIP001 	Edit                aEdtName;
//STRIP001     FixedText           aFtColor;
//STRIP001 	ColorLB             aLbColor;
//STRIP001 
//STRIP001     FixedText           aTableNameFT;
//STRIP001     ValueSet            aValSetColorTable;
//STRIP001 
//STRIP001     SvxXRectPreview     aCtlPreviewOld;
//STRIP001 	SvxXRectPreview     aCtlPreviewNew;
//STRIP001 
//STRIP001     ListBox             aLbColorModel;
//STRIP001     FixedText           aFtColorModel1;
//STRIP001 	MetricField         aMtrFldColorModel1;
//STRIP001     FixedText           aFtColorModel2;
//STRIP001 	MetricField         aMtrFldColorModel2;
//STRIP001     FixedText           aFtColorModel3;
//STRIP001 	MetricField         aMtrFldColorModel3;
//STRIP001 
//STRIP001     FixedText           aFtColorModel4;
//STRIP001 	MetricField         aMtrFldColorModel4;
//STRIP001 
//STRIP001     PushButton          aBtnAdd;
//STRIP001 	PushButton          aBtnModify;
//STRIP001 	PushButton          aBtnWorkOn;
//STRIP001 	PushButton          aBtnDelete;
//STRIP001 	ImageButton         aBtnLoad;
//STRIP001 	ImageButton         aBtnSave;
//STRIP001 
//STRIP001 	const SfxItemSet&   rOutAttrs;
//STRIP001 
//STRIP001 	XColorTable*        pColorTab;
//STRIP001 
//STRIP001 	ChangeType*         pnColorTableState;
//STRIP001 	USHORT*             pPageType;
//STRIP001 	USHORT*             pDlgType;
//STRIP001 	USHORT*             pPos;
//STRIP001 	BOOL*               pbAreaTP;
//STRIP001 	BOOL                bDeleteColorTable;
//STRIP001 
//STRIP001 	XOutdevItemPool*    pXPool;
//STRIP001 	XOutputDevice       XOutOld;
//STRIP001 	XOutputDevice       XOutNew;
//STRIP001 	XFillStyleItem      aXFStyleItem;
//STRIP001 	XFillColorItem      aXFillColorItem;
//STRIP001 	XFillAttrSetItem    aXFillAttr;
//STRIP001 	SfxItemSet&         rXFSet;
//STRIP001 
//STRIP001 	ColorModel          eCM;
//STRIP001 
//STRIP001 	Color				aAktuellColor;
//STRIP001 
//STRIP001 #ifdef _SVX_TPCOLOR_CXX
//STRIP001 	void    ConvertColorValues (Color& rColor, ColorModel eModell);
//STRIP001 	void    RgbToCmyk_Impl( Color& rColor, USHORT& rK );
//STRIP001 	void    CmykToRgb_Impl( Color& rColor, const USHORT nKey );
//STRIP001 	USHORT  ColorToPercent_Impl( USHORT nColor );
//STRIP001 	USHORT  PercentToColor_Impl( USHORT nPercent );
//STRIP001 
//STRIP001 	void    FillValueSet_Impl( ValueSet& rVs );
//STRIP001 	//-----------------------------------------------------------------------------------------------------
//STRIP001 	DECL_LINK( ClickAddHdl_Impl, void * );		// Button 'Hinzufuegen'
//STRIP001 	DECL_LINK( ClickModifyHdl_Impl, void * );	// Button 'Aendern'
//STRIP001 	DECL_LINK( ClickDeleteHdl_Impl, void * );	// Button 'loeschen'
//STRIP001 	DECL_LINK( ClickWorkOnHdl_Impl, void * );	// Button 'Bearbeiten'
//STRIP001 
//STRIP001 	DECL_LINK( SelectColorLBHdl_Impl, void * );	// Farbe aus Listbox auswhlen
//STRIP001 	DECL_LINK( SelectValSetHdl_Impl, void * );	// Farbe aus Farbpalette (links) auswhlen
//STRIP001 	DECL_LINK( SelectColorModelHdl_Impl, void * );	// Auswahl Listbox 'Farbmodell'
//STRIP001 	long ChangeColorHdl_Impl( void* p );
//STRIP001 	DECL_LINK( ModifiedHdl_Impl, void * );		// Inhalt der Farbwerte-Felder wurde verndert
//STRIP001 	DECL_LINK( ClickLoadHdl_Impl, void * );		// Button 'Farbtabelle laden'
//STRIP001 	DECL_LINK( ClickSaveHdl_Impl, void * );		// Button 'Farbtabelle sichern'
//STRIP001 
//STRIP001 	long CheckChanges_Impl();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxColorTabPage( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 
//STRIP001 	void    Construct();
//STRIP001 
//STRIP001 	static  SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 	void    SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
//STRIP001 
//STRIP001 	void    SetPageType( USHORT* pInType ) { pPageType = pInType; }
//STRIP001 	void    SetDlgType( USHORT* pInType ) { pDlgType = pInType; }
//STRIP001 	void    SetPos( USHORT* pInPos ) { pPos = pInPos; }
//STRIP001 	void    SetAreaTP( BOOL* pIn ) { pbAreaTP = pIn; }
//STRIP001 
//STRIP001 	void    SetColorChgd( ChangeType* pIn ) { pnColorTableState = pIn; }
//STRIP001 
//STRIP001 	void	SetDeleteColorTable( BOOL bIn ) { bDeleteColorTable = bIn; }
//STRIP001 
//STRIP001 	virtual void FillUserData();
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_TAB_AREA_HXX

